//Title: Chainsaw
//Author: TheGeek
//Look, ma! I'm a lumberjack!
//better range

datablock AudioProfile(chainsawDrawSound)
{
   filename    = "./draw_chainsaw.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(chainsawIdleSound)
{
   filename    = "./idle_chainsaw.wav";
   description = AudioCloseLooping3d;
   preload = true;
};

datablock AudioProfile(chainsawHitSound)
{
   filename    = "./hit_chainsaw.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(chainsawActiveSound)
{
   filename    = "./active_chainsaw.wav";
   description = AudioCloseLooping3d;
   preload = true;
};

datablock ExplosionData(chainsawExplosion : hammerExplosion)
{
   soundProfile = chainsawHitSound;

   shakeCamera = true;
   camShakeFreq = "20.0 22.0 20.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;
};

//projectile
AddDamageType("chainsaw",   '<bitmap:add-ons/GameMode_DeathMatch/addons/chainsaw/ci_chainsaw> %1',    '%2 <bitmap:add-ons/GameMode_DeathMatch/addons/chainsaw/ci_chainsaw> %1',1,1);
datablock ProjectileData(chainsawProjectile)
{
   directDamage        = 20;
   impactImpulse       = 20;
   verticalImpulse     = 20;
   directDamageType  = $DamageType::chainsaw;
   radiusDamageType  = $DamageType::chainsaw;
   explosion           = chainsawExplosion;

   muzzleVelocity      = 70;
   velInheritFactor    = 1;

   armingDelay         = 0;
   lifetime            = 100;
   fadeDelay           = 100;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = false;
   gravityMod = 0.0;
};

datablock ParticleData(ChainsawSmokeParticleA)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -1;
	inheritedVelFactor   = 0.6;
	constantAcceleration = 0.0;
	lifetimeMS           = 350;
	lifetimeVarianceMS   = 55;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "1 1 1 0.1";
	colors[1]     = "1 1 1 0.0";
	sizes[0]      = 0.6;
	sizes[1]      = 0.8;

	useInvAlpha = true;
};

datablock ParticleEmitterData(ChainsawSmokeEmitterA)
{
   ejectionPeriodMS = 20;
   periodVarianceMS = 4;
   ejectionVelocity = 3;
   velocityVariance = 2;
   ejectionOffset   = 0;
   thetaMin         = 180;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 10;
   overrideAdvance = false;
   particles = "ChainsawSmokeParticleA";

   uiName = "Chainsaw Smoke A";
};

datablock ParticleData(ChainsawSmokeParticleB)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -1;
	inheritedVelFactor   = 0.6;
	constantAcceleration = 0.0;
	lifetimeMS           = 350;
	lifetimeVarianceMS   = 55;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "1 1 1 0.2";
	colors[1]     = "1 1 1 0.0";
	sizes[0]      = 0.6;
	sizes[1]      = 0.8;

	useInvAlpha = true;
};

datablock ParticleEmitterData(ChainsawSmokeEmitterB)
{
   ejectionPeriodMS = 20;
   periodVarianceMS = 4;
   ejectionVelocity = 3;
   velocityVariance = 2;
   ejectionOffset   = 0;
   thetaMin         = 180;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 30;
   overrideAdvance = false;
   particles = "ChainsawSmokeParticleB";

   uiName = "Chainsaw Smoke B";
};


//////////
// item //
//////////
datablock ItemData(chainsawItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./chainsawitem.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Chainsaw";
	iconName = "./icon_chainsaw";
	doColorShift = false;
	colorShiftColor = "0.471 0.471 0.471 1.000";

	 // Dynamic properties defined by the scripts
	image = chainsawImage;
	canDrop = true;
};


////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(chainsawImage)
{
   // Basic Item properties
   shapeFile = "./chainsawweapon.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   //rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = false;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = chainsawItem;
   ammo = " ";
   projectile = chainsawProjectile;
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   melee = false;
   doRetraction = true;
   //raise your arm up or not
   armReady = true;

   //casing = " ";
   doColorShift = false;
   colorShiftColor = "0.471 0.471 0.471 1.000";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.5;
	stateTransitionOnTimeout[0]      = "Ready";
	stateSound[0]                    = chainsawDrawSound;

	stateName[1]			= "Ready";
	stateTransitionOnTriggerDown[1]	= "Fire";
	stateAllowImageChange[1]	= true;
	stateTimeoutValue[1]		= 0.1;
	stateTransitionOnTimeout[1]	= "Ready";
	stateSequence[1]		= "Active";
	stateSound[1]			= chainsawIdleSound;
	stateEmitter[1]                 = ChainsawSmokeEmitterA;
	stateEmitterNode[1]		= everything;
	stateEmitterTime[1]		= 0.2;

	stateName[2]			= "Fire";
	stateScript[2]			= "onFire";
	stateFire[2]			= true;
	stateAllowImageChange[2]	= true;
	stateTimeoutValue[2]		= 0.10;
	stateTransitionOnTimeout[2]	= "Fire";
	stateTransitionOnTriggerUp[2]	= "Ready";
	stateSound[2]			= chainsawActiveSound;
	stateSequence[2]		= "TrigDown";
	stateEmitter[2]			= ChainsawSmokeEmitterB;
	stateEmitterNode[2]		= everything;
	stateEmitterTime[2]		= 0.2;
};

function chainsawProjectile::Damage(%this, %obj, %col, %fade, %pos, %normal)
{
	if(%col.gettype() & $TypeMasks::PlayerObjectType && fileName(%col.dataBlock.shapeFile) $= "m.dts")
	{
		//%damLoc = %col.getDamageLocation(%pos);
		%fvec = %col.getForwardVector();
		%vec1 = -getWord(%fvec,1) SPC getWord(%fvec,0) SPC 0;	
		%vec2 = vectorNormalize(%obj.initialVelocity);
		
		%damloc = (vectorDot(%vec1,%vec2) > 0);
		
		%scale = getWord(%col.getScale(),2);
		if(getword(%pos, 2) > getword(%col.getWorldBoxCenter(), 2) - 3.3*%scale)
		{
			%hidestr = "headskin";
			for(%i=0;$hat[%i] !$= "";%i++) %hidestr = %hidestr SPC $hat[%i];
			for(%i=0;$accent[%i] !$= "";%i++) %hidestr = %hidestr SPC $accent[%i];
		}
		else if(getword(%pos, 2) > getword(%col.getWorldBoxCenter(), 2) - 4.5*%scale)
		{
			//Torso shot
			if(%damLoc == 0)
			{
				%hidestr = "lhand lhook larm larmslim";
			}
			else
			{
				%hidestr = "rhand rhook rarm rarmslim";
			}
		}
		else
		{
			//Leg shot
			if(%damLoc == 0)
			{
				%hidestr = "lshoe lpeg";
			}
			else
			{
				%hidestr = "rshoe rpeg";
			}
		}
		
		if(%col.chainSawUnhideStr $= "")
			%col.chainSawUnhideStr = "START";
		
		for(%i=0;%i<getWordCount(%hidestr);%i++)
		{
			%node = getWord(%hidestr,%i);
			if(%col.isNodeVisible(%node) && strStr(%col.chainsawUnhideStr," " @ %node) == -1)
				%col.chainsawUnhideStr = %col.chainsawUnhideStr SPC %node;
			
			%col.hideNode(%node);
		}
		
		cancel(%col.chainsawResetSched);
		%col.chainsawResetSched = %col.schedule(5000,chainsawReset);
	}
	
	return Parent::Damage(%this, %obj, %col, %fade, %pos, %normal);
}

function Player::chainsawReset(%this)
{
	%this.spawnExplosion(playerTeleportProjectile.getID(),getWord(%this.getScale(),2)*0.75,%this.client);
	if(isObject(%this.client))
	{
		%this.unHideNode("headskin");
		%this.client.applyBodyParts();
		%this.client.applyBodyColors();
	}
	else
	{
		for(%i=1;%i<getWordCount(%this.chainsawUnhideStr);%i++)
			%this.unHideNode(getWord(%this.chainsawUnhideStr,%i));
		%this.chainsawUnhideStr = "";
	}
}

function ChainsawImage::onFire(%this, %obj, %slot)
{
   if($AddOn__Gamemode_zombie >= 1 && isInMinigame(%obj) && %obj.client.minigame.enableAmmoMod == 1)
   {   
      if(%obj.zombieammo[%this.projectile] == -1)
      {
         %obj.client.bottomPrint("<just:center><color:FFFF00>Ammo <color:FFFFFF>: <just:left><color:FF0000> NONE", 3);
         return;
      }
      if(%obj.zombieammo[%this.projectile] >= 1)
      {
         %obj.zombieammo[%this.projectile]--;
         bottomPrintRemainingAmmo(%obj, %this);
      }
      if(%obj.zombieammo[%this.projectile] <= 0)
      {
         %obj.zombieammo[%this.projectile] = -1;
         
         if(isObject(%obj.getMountedImage(0).getName() @ "NoFire"))
            %obj.mountImage(%obj.getMountedImage(0).getName() @ "NoFire",0);
         
         %obj.client.bottomPrint("<just:center><color:FFFF00>Ammo <color:FFFFFF>: <just:left><color:FF0000> NONE", 3);
         %obj.playAudio(1, ammocratesound);
         %obj.playThread(2, activate2);
         return;
      }
   }
   %this.melee = 1;
   Parent::onFire(%this, %obj, %slot);
   %this.melee = 0;
}

function ChainsawZombies()
{
   $zombie::ammo::Gun[$zombie::ammo::Listcount++] = ChainsawProjectile;
   $zombie::ammo::AmmoChainsawProjectile = 40;
   if(isObject(gunImageNoFire))
   {
      datablock ShapeBaseImageData(ChainsawImageNoFire : gunImageNoFire)
      {
         shapeFile = "./ChainsawWeapon.dts";
         RWep = "ChainsawImage";
         projectile = ChainsawProjectile;
         doColorShift = ChainsawItem.doColorShift;
         colorShiftColor = ChainsawItem.colorShiftColor;
         offset = ChainsawImage.offset;
         eyeoffset = ChainsawImage.eyeoffset;
      };
   }
}
schedule(100, 0, ChainsawZombies);