function DM_getAchievementDescription(%achievement)
{
	%description = "\c0ERROR: Got a description for an achievement that has none, or the achievement doesn't exist.";
	
	if(%achievement $= "My First Kill")
		%description = "Make your first kill.";
	if(%achievement $= "Hugs Make Things Better")
		%description = "Use the hug command.";
	if(%achievement $= "I Think it Burns")
		%description = "Jump in to a pool of lava.";
	if(%achievement $= "Fallure")
		%description = "Fall ten times and die.";
	
	if(%achievement $= "Empty House")
		%description = "Kill 32 players.";
	if(%achievement $= "Hacker")
		%description = "Try to use a gamemode debug command.";
	if(%achievement $= "Self Help")
		%description = "Use the help command.";
	if(%achievement $= "SUPER High Score")
		%description = "Have at least 1000 points.";
	if(%achievement $= "High Score")
		%description = "Have at least 1 point.";
	if(%achievement $= "Cheater")
		%description = "Try to teleport.";
	
	if(%achievement $= "Treasure")
		%description = "Find a treasure chest.";
	if(%achievement $= "Treasure Hunter")
		%description = "Find all treasure chests in a map.";
	if(%achievement $= "Batting Ace")
		%description = "Perform a Home Run.";
	if(%achievement $= "Knife Master")
		%description = "Perform a Back Stab.";
	if(%achievement $= "Whack a Block")
		%description = "Squish a player.";
	if(%achievement $= "Block to Horse")
		%description = "Transform a player into a horse.";
	if(%achievement $= "Cheep Cheep Haha")
		%description = "Transform a player into a chicken.";
	if(%achievement $= "Helping Hand")
		%description = "Transform a player back into a blockhead.";
	if(%achievement $= "Big Boned")
		%description = "Enlarge a player.";
	if(%achievement $= "Blockland Bug")
		%description = "Shrink a player.";
	if(%achievement $= "Key Finder")
		%description = "Find a key.";
	if(%achievement $= "Skeleton Key")
		%description = "Have all four keys.";
	if(%achievement $= "Blocks Dont Need Brains")
		%description = "Remove a player's head using the chainsaw.";
	if(%achievement $= "Hand to Gun Combat")
		%description = "Kill a player with the fist.";
	if(%achievement $= "Hand Gun to Gun Combat")
		%description = "Kill a player with the hand gun.";
	if(%achievement $= "Headshot")
		%description = "Perform a headshot with the Tranquilizer.";
	if(%achievement $= "Sneak Attack")
		%description = "Kill a player while cloaked.";
	if(%achievement $= "Wrench Master")
		%description = "Kill a player with a critical wrench attack.";
	if(%achievement $= "Road Kill")
		%description = "Kill a player by running them over with a vehicle.";
	if(%achievement $= "Winner")
		%description = "Win your first round.";
	if(%achievement $= "Sharp Eyes")
		%description = "Kill a cloaking player.";
	if(%achievement $= "Revenge")
		%description = "Kill a player who is dominating you.";
	if(%achievement $= "Domination")
		%description = "Dominate a player.";
	if(%achievement $= "Speed Killer")
		%description = "Kill two players in quick succession.";
	if(%achievement $= "Survivor")
		%description = "Achieve a kill streak.";
	
	return %description;
}

function GameConnection::DM_getAchievementListString(%this, %achievement)
{
	if(%this.unLockedAchievements[%achievement])
		messageClient(%this, '', "<bitmap:base/client/ui/ci/star> \c3" @ %achievement @ " \c6- " @ DM_getAchievementDescription(%achievement));
	else
		messageClient(%this, '', "    \c7" @ %achievement @ " - " @ DM_getAchievementDescription(%achievement));
}

function serverCmdAchievements(%client)
{
	if(!$Pref::Server::DeathMatch::Achievements)
		return;
	
	messageClient(%this, '', "\c6All the achievements in the gamemode:");
	%client.DM_getAchievementListString("My First Kill");
	%client.DM_getAchievementListString("Hugs Make Things Better");
	%client.DM_getAchievementListString("I Think it Burns");
	%client.DM_getAchievementListString("Fallure");
	
	%client.DM_getAchievementListString("Empty House");
	%client.DM_getAchievementListString("Hacker");
	%client.DM_getAchievementListString("Self Help");
	%client.DM_getAchievementListString("SUPER High Score");
	%client.DM_getAchievementListString("High Score");
	%client.DM_getAchievementListString("Cheater");
	
	%client.DM_getAchievementListString("Treasure");
	%client.DM_getAchievementListString("Treasure Hunter");
	%client.DM_getAchievementListString("Batting Ace");
	%client.DM_getAchievementListString("Knife Master");
	%client.DM_getAchievementListString("Whack a Block");
	%client.DM_getAchievementListString("Block to Horse");
	%client.DM_getAchievementListString("Cheep Cheep Haha");
	%client.DM_getAchievementListString("Helping Hand");
	%client.DM_getAchievementListString("Big Boned");
	%client.DM_getAchievementListString("Blockland Bug");
	%client.DM_getAchievementListString("Key Finder");
	%client.DM_getAchievementListString("Skeleton Key");
	%client.DM_getAchievementListString("Blocks Dont Need Brains");
	%client.DM_getAchievementListString("Hand to Gun Combat");
	%client.DM_getAchievementListString("Hand Gun to Gun Combat");
	%client.DM_getAchievementListString("Headshot");
	%client.DM_getAchievementListString("Sneak Attack");
	%client.DM_getAchievementListString("Wrench Master");
	%client.DM_getAchievementListString("Road Kill");
	%client.DM_getAchievementListString("Winner");
	%client.DM_getAchievementListString("Sharp Eyes");
	%client.DM_getAchievementListString("Revenge");
	%client.DM_getAchievementListString("Domination");
	%client.DM_getAchievementListString("Speed Killer");
	%client.DM_getAchievementListString("Survivor");
}

function sendAchievements(%client) //overwriting the original add-on, we're taking over!
{
	//the achievements gui is glitched where the scroll bar wont allow players to scroll beyond what's in the general group
	//we're going to set all of them to be in the general category and if a workaround is found later on we can easily just change these
	//and no, releasing a fixed version of the mod will NOT work as there will still be people with the older version, and not many people will have the mod in the first place
	%general = "General";
	%deathmatch = "General";
	%special = "General";
	
	//Edited Originals
	sendLockedAchievementToClient(%client, "pwned",		"My First Kill",			DM_getAchievementDescription("My First Kill"),				%deathmatch);
	sendLockedAchievementToClient(%client, "hugger",	"Hugs Make Things Better",	DM_getAchievementDescription("Hugs Make Things Better"),	%general);
	sendLockedAchievementToClient(%client, "censored",	"I Think it Burns",			DM_getAchievementDescription("I Think it Burns"),			%deathmatch);
	sendLockedAchievementToClient(%client, "fail",		"Fallure",					DM_getAchievementDescription("Fallure"),					%deathmatch);
	
	//Edited Steam Ports
	sendLockedAchievementToClient(%client, "heart",		"Empty House",				DM_getAchievementDescription("Empty House"),				%deathmatch);
	sendLockedAchievementToClient(%client, "bsod",		"Hacker",					DM_getAchievementDescription("Hacker"),						%special);
	sendLockedAchievementToClient(%client, "pa",		"Self Help",				DM_getAchievementDescription("Self Help"),					%general);
	sendLockedAchievementToClient(%client, "moneysign",	"SUPER High Score",			DM_getAchievementDescription("SUPER High Score"),			%deathmatch);
	sendLockedAchievementToClient(%client, "crap",		"High Score",				DM_getAchievementDescription("High Score"),					%deathmatch);
	sendLockedAchievementToClient(%client, "pacman",	"Cheater",					DM_getAchievementDescription("Cheater"),					%special);
	
	//Added
	sendLockedAchievementToClient(%client, "moneysign",	"Treasure",					DM_getAchievementDescription("Treasure"),					%general);
	sendLockedAchievementToClient(%client, "lego",		"Treasure Hunter",			DM_getAchievementDescription("Treasure Hunter"),			%general);
	sendLockedAchievementToClient(%client, "pwned",		"Batting Ace",				DM_getAchievementDescription("Batting Ace"),				%deathmatch);
	sendLockedAchievementToClient(%client, "pwned",		"Knife Master",				DM_getAchievementDescription("Knife Master"),				%deathmatch);
	sendLockedAchievementToClient(%client, "lol",		"Whack A Block",			DM_getAchievementDescription("Whack A Block"),				%general);
	sendLockedAchievementToClient(%client, "unknown",	"Block To Horse",			DM_getAchievementDescription("Block To Horse"),				%general);
	sendLockedAchievementToClient(%client, "lol",		"Cheep Cheep Haha",			DM_getAchievementDescription("Cheep Cheep Haha"),			%general);
	sendLockedAchievementToClient(%client, "mw",		"Helping Hand",				DM_getAchievementDescription("Helping Hand"),				%general);
	sendLockedAchievementToClient(%client, "unknown",	"Big Boned",				DM_getAchievementDescription("Big Boned"),					%general);
	sendLockedAchievementToClient(%client, "trash",		"Blockland Bug",			DM_getAchievementDescription("Blockland Bug"),				%general);
	sendLockedAchievementToClient(%client, "unknown",	"Key Finder",				DM_getAchievementDescription("Key Finder"),					%general);
	sendLockedAchievementToClient(%client, "unknown",	"Skeleton Key",				DM_getAchievementDescription("Skeleton Key"),				%general);
	sendLockedAchievementToClient(%client, "censored",	"Blocks Dont Need Brains",	DM_getAchievementDescription("Blocks Dont Need Brains"),	%deathmatch);
	sendLockedAchievementToClient(%client, "unknown",	"Hand to Gun Combat",		DM_getAchievementDescription("Hand to Gun Combat"),			%deathmatch);
	sendLockedAchievementToClient(%client, "banana",	"Hand Gun to Gun Combat",	DM_getAchievementDescription("Hand Gun to Gun Combat"),		%deathmatch);
	sendLockedAchievementToClient(%client, "target",	"Headshot",					DM_getAchievementDescription("Headshot"),					%deathmatch);
	sendLockedAchievementToClient(%client, "eye",		"Sneak Attack",				DM_getAchievementDescription("Sneak Attack"),				%deathmatch);
	sendLockedAchievementToClient(%client, "unknown",	"Wrench Master",			DM_getAchievementDescription("Wrench Master"),				%deathmatch);
	sendLockedAchievementToClient(%client, "unknown",	"Road Kill",				DM_getAchievementDescription("Road Kill"),					%deathmatch);
	sendLockedAchievementToClient(%client, "number1",	"Winner",					DM_getAchievementDescription("Winner"),						%deathmatch);
	sendLockedAchievementToClient(%client, "eye",		"Sharp Eyes",				DM_getAchievementDescription("Sharp Eyes"),					%deathmatch);
	sendLockedAchievementToClient(%client, "target",	"Revenge",					DM_getAchievementDescription("Revenge"),					%deathmatch);
	sendLockedAchievementToClient(%client, "target",	"Domination",				DM_getAchievementDescription("Domination"),					%deathmatch);
	sendLockedAchievementToClient(%client, "target",	"Speed Killer",				DM_getAchievementDescription("Speed Killer"),				%deathmatch);
	sendLockedAchievementToClient(%client, "target",	"Survivor",					DM_getAchievementDescription("Survivor"),					%deathmatch);
}

function GameConnection::DM_onDeathAchievements(%this, %killer, %damageType, %playerPosition, %killerCloaking, %playerCloaking)
{
	if(%killer != %this && isObject(%killer))
	{
		unlockClientAchievement(%killer, "My First Kill");
		
		if($DeathMatch_Player[%killer.bl_id, "Kills"] >= 32)
			unlockClientAchievement(%killer, "Empty House");
		
		if(%killerCloaking)
			unlockClientAchievement(%killer, "Sneak Attack");
		
		if(%damageType $= $DamageType::fist)
			unlockClientAchievement(%killer, "Hand to Gun Combat");
		
		if(%damageType $= $DamageType::HandgunB)
			unlockClientAchievement(%killer, "Hand Gun to Gun Combat");
		
		if(%damageType $= $DamageType::wrenchWeaponDirect)
			unlockClientAchievement(%killer, "Wrench Master");
		
		if(%damageType $= $DamageType::butterflyknifeDirectBackStab)
			unlockClientAchievement(%killer, "Knife Master");
		
		if(%damageType $= $DamageType::redBaseballBat)
			unlockClientAchievement(%killer, "Batting Ace");
		
		if(%damageType $= $DamageType::Vehicle)
			unlockClientAchievement(%killer, "Road Kill");
		
		if(%playerCloaking)
			unlockClientAchievement(%killer, "Sharp Eyes");
	}
	
	if(%damageType $= $DamageType::Lava || %damageType $= $DamageType::Fall) 
	{
		$DeathMatch_Player[%this.bl_id, "LavaDeaths"]++;
		unlockClientAchievement(%this, "I Think it Burns");
		
		if($DeathMatch_Player[%this.bl_id, "LavaDeaths"] >= 10)
			unlockClientAchievement(%this, "Fallure");
	}
}

if(isPackage(DMAchievementsPackage))
	deactivatePackage(DMAchievementsPackage);
package DMAchievementsPackage
{
	function GameConnection::onDeath(%this, %killerPlayer, %killer, %damageType, %damageLoc)
	{
		%player = %this.player;
		if(isObject(%player))
		{
			%playerPosition = %player.getPosition();
			%killerCloaking = %killer.player.Cloaking;
			%playerCloaking = %player.Cloaking;
			//we put this in its own function so we can workaround some of the death message stuff easily
			%this.DM_onDeathAchievements(%killer, %damageType, %playerPosition, %killerCloaking, %playerCloaking);
		}
		
		parent::onDeath(%this, %killerPlayer, %killer, %damageType, %damageLoc);
	}
	
	function GameConnection::incScore(%this, %amount)
	{
		Parent::incScore(%this, %amount);
		
		if(!%this.unLockedAchievements["SUPER High Score"] && %this.score >= 1000)
			unlockClientAchievement(%this, "SUPER High Score");
		
		if(!%this.unLockedAchievements["High Score"] && %this.score >= 1)
			unlockClientAchievement(%this, "High Score");
	}
	
	function serverCmdHug(%client)
	{
		parent::serverCmdHug(%client);
		
		if(isObject(%client.player))
			unlockClientAchievement(%client, "Hugs Make Things Better");
	}
	
	function serverCmdDMDebug(%client)
	{
		parent::serverCmdDMDebug(%client);
		unlockClientAchievement(%client, "Hacker");
	}
	
	function serverCmdDRoundInfo(%client)
	{
		parent::serverCmdDRoundInfo(%client);
		unlockClientAchievement(%client, "Hacker");
	}
	
	function serverCmdDMapInfo(%client)
	{
		parent::serverCmdDMapInfo(%client);
		unlockClientAchievement(%client, "Hacker");
	}
	
	function serverCmdDFakeClient(%client)
	{
		parent::serverCmdDFakeClient(%client);
		unlockClientAchievement(%client, "Hacker");
	}
	
	function serverCmdDPlayerScores(%client)
	{
		parent::serverCmdDPlayerScores(%client);
		unlockClientAchievement(%client, "Hacker");
	}
	
	function serverCmdDPlayerTeams(%client)
	{
		parent::serverCmdDPlayerTeams(%client);
		unlockClientAchievement(%client, "Hacker");
	}
	
	function serverCmdDPlayerHealth(%client)
	{
		parent::serverCmdDPlayerHealth(%client);
		unlockClientAchievement(%client, "Hacker");
	}
	
	function serverCmdHelp(%client)
	{
		parent::serverCmdHelp(%client);
		unlockClientAchievement(%client, "Self Help");
	}
	
	function serverCmdDropPlayerAtCamera(%client)
	{
		Parent::serverCmdDropPlayerAtCamera(%client);
		unlockClientAchievement(%client, "Cheater");
	}
	
	function serverCmdFind(%client, %target)
	{
		Parent::serverCmdFind(%client, %target);
		unlockClientAchievement(%client, "Cheater");
	}
	
	function serverCmdFetch(%client, %target)
	{
		Parent::serverCmdFetch(%client, %target);
		unlockClientAchievement(%client, "Cheater");
	}
	
	function serverCmdWarp(%client)
	{
		Parent::serverCmdWarp(%client);
		unlockClientAchievement(%client, "Cheater");
	}
	
	function brickTreasureChestData::openTreasureChest(%data ,%obj, %player)
	{
		Parent::openTreasureChest(%data ,%obj, %player);
		%client = %player.client;
		if(!isObject(%client))
			return;
		
		unlockClientAchievement(%client, "Treasure");
		if(%client.numFoundTreasureChests >= $TreasureChest::NumChests)
			unlockClientAchievement(%client, "Treasure Hunter");
	}

	function airhammerProjectile::onCollision(%this, %obj, %col, %fade, %pos, %normal)
	{
		%client = %obj.client;
		if(!isObject(%client))
			return;
		
		if(%obj == %col)
			return;
		
		if(isObject(%client) && %col.getType() & $TypeMasks::PlayerObjectType)
		{
			%scaleBefore = %col.getscale();
			parent::onCollision(%this, %obj, %col, %fade, %pos, %normal);
			%scaleAfter = %col.getscale();
			
			if(%scaleBefore !$= %scaleAfter)
				unlockClientAchievement(%client, "Whack A Block");
		}
		else
			parent::onCollision(%this, %obj, %col, %fade, %pos, %normal);
	}
	
	function HorseRayProjectile::Damage(%this,%obj,%col,%fade,%pos,%normal)
	{
		%client = %obj.client;
		if(!isObject(%client))
			return;
		
		if(%obj == %col)
			return;
		
		if(%col.getType() & $TypeMasks::PlayerObjectType)
		{
			%dataBefore = %col.getDatablock();
			parent::Damage(%this,%obj,%col,%fade,%pos,%normal);
			%dataAfter = %col.getDatablock();
			
			if(%dataBefore != %dataAfter)
				unlockClientAchievement(%client, "Block To Horse");
		}
		else
			parent::Damage(%this,%obj,%col,%fade,%pos,%normal);
	}
	
	function ChickenRayProjectile::Damage(%this,%obj,%col,%fade,%pos,%normal)
	{
		%client = %obj.client;
		if(!isObject(%client))
			return;
		
		if(%obj == %col)
			return;
		
		if(%col.getType() & $TypeMasks::PlayerObjectType)
		{
			%dataBefore = %col.getDatablock();
			parent::Damage(%this,%obj,%col,%fade,%pos,%normal);
			%dataAfter = %col.getDatablock();
			
			if(%dataBefore != %dataAfter)
				unlockClientAchievement(%client, "Cheep Cheep Haha");
		}
		else
			parent::Damage(%this,%obj,%col,%fade,%pos,%normal);
	}
	
	function blockheadRayProjectile::Damage(%this,%obj,%col,%fade,%pos,%normal)
	{
		%client = %obj.client;
		if(!isObject(%client))
			return;
		
		if(%obj == %col)
			return;
		
		if(%col.getType() & $TypeMasks::PlayerObjectType)
		{
			%dataBefore = %col.getDatablock();
			%modelBefore = fileName(%dataBefore.shapeFile);
			parent::Damage(%this,%obj,%col,%fade,%pos,%normal);
			%dataAfter = %col.getDatablock();
			%modelAfter = fileName(%dataAfter.shapeFile);
			
			if(%modelBefore !$= %modelAfter)
				unlockClientAchievement(%client, "Helping Hand");
		}
		else
			parent::Damage(%this,%obj,%col,%fade,%pos,%normal);
	}

	function AntiShrinkRayProjectile::onCollision(%this, %obj, %col, %fade, %pos, %norm)
	{
		%client = %obj.client;
		if(!isObject(%client))
			return;
		
		if(%obj == %col)
			return;
		
		if(%col.getType() & $TypeMasks::PlayerObjectType)
		{
			%scaleBefore = %col.getscale();
			parent::onCollision(%this, %obj, %col, %fade, %pos, %norm);
			%scaleAfter = %col.getscale();
			
			if(%scaleBefore !$= %scaleAfter)
				unlockClientAchievement(%client, "Big Boned");
		}
		else
			parent::onCollision(%this, %obj, %col, %fade, %pos, %norm);
	}
	
	function ShrinkRayProjectile::onCollision(%this, %obj, %col, %fade, %pos, %norm)
	{
		%client = %obj.client;
		if(!isObject(%client))
			return;
		
		if(%obj == %col)
			return;
		
		if(%col.getType() & $TypeMasks::PlayerObjectType)
		{
			%scaleBefore = %col.getscale();
			parent::onCollision(%this, %obj, %col, %fade, %pos, %norm);
			%scaleAfter = %col.getscale();
			
			if(%scaleBefore !$= %scaleAfter)
				unlockClientAchievement(%client, "Blockland Bug");
		}
		else
			parent::onCollision(%this, %obj, %col, %fade, %pos, %norm);
	}
	
	function Armor::onCollision(%this, %obj, %col, %a, %b, %c, %d, %e, %f)
	{
		if(%col.canPickup && isObject(%obj.client))
		{
			%client = %obj.client;
			if(%col.dataBlock $= "redKeyItem")
				unlockClientAchievement(%client, "Key Finder");
			else if(%col.dataBlock $= "yellowKeyItem")
				unlockClientAchievement(%client, "Key Finder");
			else if(%col.dataBlock $= "greenKeyItem")
				unlockClientAchievement(%client, "Key Finder");
			else if(%col.dataBlock $= "blueKeyItem")
				unlockClientAchievement(%client, "Key Finder");
			
			Parent::onCollision(%this, %obj, %col, %a, %b, %c, %d, %e, %f);
			
			%keyCount = %client.DMHasKey_Red + %client.DMHasKey_Yellow + %client.DMHasKey_Green + %client.DMHasKey_Blue;
			if(%keyCount >= 4)
				unlockClientAchievement(%client, "Skeleton Key");
		}
		else
			Parent::onCollision(%this, %obj, %col, %a, %b, %c, %d, %e, %f);
	}
	
	function chainsawProjectile::Damage(%this, %obj, %col, %fade, %pos, %normal)
	{
		Parent::Damage(%this, %obj, %col, %fade, %pos, %normal);
		
		%client = %obj.client;
		if(!isObject(%client))
			return;
		
		if(%obj == %col)
			return;
		
		if(%col.gettype() & $TypeMasks::PlayerObjectType && fileName(%col.dataBlock.shapeFile) $= "m.dts")
		{
			%scale = getWord(%col.getScale(), 2);
			if(getword(%pos, 2) > getword(%col.getWorldBoxCenter(), 2) - 3.3 * %scale)
				unlockClientAchievement(%client, "Blocks Dont Need Brains");
		}
	}
	
	function blueTranquilizerProjectile::damage(%this,%obj,%col,%fade,%pos,%normal)
	{
		Parent::damage(%this,%obj,%col,%fade,%pos,%normal);
		
		%client = %obj.client;
		if(!isObject(%client))
			return;
		
		if(%obj == %col)
			return;
		
		if(%col.getType() & $TypeMasks::PlayerObjectType)
		{
			%colscale = getWord(%col.getScale(), 2);
			if(getword(%pos, 2) > getword(%col.getWorldBoxCenter(), 2) - 3.3 * %colscale)
				unlockClientAchievement(%client, "Headshot");
		}
	}
	
	function DM_doRoundEnd()
	{
		Parent::DM_doRoundEnd();
		
		for(%a = 0; %a < $DefaultMinigame.numMembers; %a++)
		{
			%member = $DefaultMinigame.member[%a];
			if(isObject(%member))
			{
				if(%member.DMWinner)
					unlockClientAchievement(%member, "Winner");
			}
		}
	}
	
	function GenerateKS(%Killer,%Killed,%Kills)
	{
		if(%killed.Domination[%Killer] > 2)
			unlockClientAchievement(%Killer, "Revenge");
		
		if(%killer.Domination[%Killed] == 3)
			unlockClientAchievement(%Killer, "Domination");
		
		if(%Killer.MultiKills > 1)
			unlockClientAchievement(%Killer, "Speed Killer");
		
		if(%Kills >= 3)
			unlockClientAchievement(%Killer, "Survivor");
		
		Parent::GenerateKS(%Killer,%Killed,%Kills);
	}
};
activatePackage(DMAchievementsPackage);