function serverCmdDMDebug(%client)
{
	if(%client.bl_id != getNumKeyID())
		return;
	
	messageClient(%client, '', "\c6Here is a list of commands under \c2dmDebug\c6. \c7DM_Debug();");
	messageClient(%client, '', "\c6 - \c3/mapList all \c6- Lists every single map that exists in the server. \c7DM_DumpMapList();");
	messageClient(%client, '', "\c6 - \c3/teamList \c6- Lists all valid teams. \c7DM_DumpTeamList();");
	messageClient(%client, '', "\c6 - \c3/dRoundInfo \c6- Displays round info. \c7DM_DumpRoundInfo();");
	messageClient(%client, '', "\c6 - \c3/dMapInfo \c6- Displays map info. \c7DM_DumpMapInfo();");
	messageClient(%client, '', "\c6 - \c3/dFakeClient \c6- Displays info about the fake client. \c7DM_DumpFakeClient();");
	messageClient(%client, '', "\c6 - \c3/dPlayerScores \c6- Lists all player scores. \c7DM_DumpPlayerScores();");
	messageClient(%client, '', "\c6 - \c3/dPlayerTeams \c6- Lists all player teams. \c7DM_DumpPlayerTeams();");
	messageClient(%client, '', "\c6 - \c3/dPlayerHealth \c6- List all players' health. \c7DM_DumpPlayerHealth();");
}

function DM_Debug()
{
	echo("");
	
	echo("Here is a list of useful console commands:");
	echo(" - DM_DumpMapList();      - Lists every single map that exists in the server.");
	echo(" - DM_DumpTeamList();     - Lists all valid teams.");
	echo(" - DM_DumpRoundInfo();    - Displays round info.");
	echo(" - DM_DumpMapInfo();      - Displays map info.");
	echo(" - DM_DumpFakeClient();   - Displays info about the fake client.");
	echo(" - DM_DumpPlayerScores(); - Lists all player scores.");
	echo(" - DM_DumpPlayerTeams();  - Lists all player teams.");
	echo(" - DM_DumpPlayerHealth(); - Lists all players' health.");
	
	echo("");
}

function DM_DumpMapList()
{
	echo("");
	
	if($DM::numMaps == 1)
		echo("1 map");
	else
		echo($DM::numMaps @ " maps");
	
	for(%i = 0; %i < $DM::numMaps; %i++)
	{
		if(%i == $DM::CurrentMap)
			echo(" >" @ DM_getMapName(%i));
		else
			echo("  " @ DM_getMapName(%i));
	}
	
	echo("");
}

function DM_DumpTeamList()
{
	echo("Valid teams:");
	echo("RED");
	echo("BLUE");
	echo("GREEN");
	echo("YELLOW");
	echo("CYAN");
	echo("MAGENTA");
	echo("WHITE");
	echo("BLACK");
	echo("ORANGE");
	echo("BROWN");
	echo("PURPLE");
	echo("PINK");
}

function serverCmdDRoundInfo(%client)
{
	if(%client.bl_id != getNumKeyID())
		return;
	
	messageClient(%client, '', "\c6Round info:");
	messageClient(%client, '', $DM::RoundName);
	messageClient(%client, '', $DM::RoundDesc);
	if($DM::TeamRoundType $= "NONE")
		messageClient(%client, '', "\c6Is not a team round");
	else if($DM::TeamRoundType $= "TEAMS")
		messageClient(%client, '', "\c6Is a two team round");
	else if($DM::TeamRoundType $= "4TEAMS")
		messageClient(%client, '', "\c6Is a four team round");
	else
		messageClient(%client, '', "\c6Team round type is not set!!!");
	messageClient(%client, '', DM_getTeamColorString($DM::teamColor1) @ $DM::teamColor1 @ " \c6vs " @ DM_getTeamColorString($DM::teamColor2) @ $DM::teamColor2 @ " \c6vs " @ DM_getTeamColorString($DM::teamColor3) @ $DM::teamColor3 @ " \c6vs " @ DM_getTeamColorString($DM::teamColor4) @ $DM::teamColor4 @ " \c6teams");
	messageClient(%client, '', DM_getTeamColorString($DM::teamColor1) @ $DM::TeamPlayers1 @ " \c6vs " @ DM_getTeamColorString($DM::teamColor2) @ $DM::TeamPlayers2 @ " \c6vs " @ DM_getTeamColorString($DM::teamColor3) @ $DM::TeamPlayers3 @ " \c6vs " @ DM_getTeamColorString($DM::teamColor4) @ $DM::TeamPlayers4 @ " \c6players");
	messageClient(%client, '', DM_getTeamColorString($DM::teamColor1) @ $DM::TeamScore1 @ " \c6vs " @ DM_getTeamColorString($DM::teamColor2) @ $DM::TeamScore2 @ " \c6vs " @ DM_getTeamColorString($DM::teamColor3) @ $DM::TeamScore3 @ " \c6vs " @ DM_getTeamColorString($DM::teamColor4) @ $DM::TeamScore4 @ " \c6scores");
	messageClient(%client, '', "\c6Normal loadout: \c3" @ $DM::Item0Spawn SPC $DM::Item1Spawn SPC $DM::Item2Spawn SPC $DM::Item3Spawn SPC $DM::Item4Spawn);
	messageClient(%client, '', "\c6Random balance loadout: \c3" @ $DM::Item0Random SPC $DM::Item1Random SPC $DM::Item2Random SPC $DM::PlayertypeRandom);
}

function DM_DumpRoundInfo()
{
	echo("Round info:");
	echo($DM::RoundName);
	echo($DM::RoundDesc);
	if($DM::TeamRoundType $= "NONE")
		echo("Is not a team round");
	else if($DM::TeamRoundType $= "TEAMS")
		echo("Is a two team round");
	else if($DM::TeamRoundType $= "4TEAMS")
		echo("Is a four team round");
	else
		echo("Team round type is not set!!!");
	echo($DM::teamColor1 @ " vs " @ $DM::teamColor2 @ " vs " @ $DM::teamColor3 @ " vs " @ $DM::teamColor4 @ " teams");
	echo($DM::TeamPlayers1 @ " vs " @ $DM::TeamPlayers2 @ " vs " @ $DM::TeamPlayers3 @ " vs " @ $DM::TeamPlayers4 @ " players");
	echo($DM::TeamScore1 @ " vs " @ $DM::TeamScore2 @ " vs " @ $DM::TeamScore3 @ " vs " @ $DM::TeamScore4 @ " scores");
	echo("Normal loadout: " @ $DM::Item0Spawn SPC $DM::Item1Spawn SPC $DM::Item2Spawn SPC $DM::Item3Spawn SPC $DM::Item4Spawn);
	echo("Random balance loadout: " @ $DM::Item0Random SPC $DM::Item1Random SPC $DM::Item2Random SPC $DM::PlayertypeRandom);
}

function serverCmdDMapInfo(%client)
{
	if(%client.bl_id != getNumKeyID())
		return;
	
	messageClient(%client, '', "\c6Map info:");
	messageClient(%client, '', "\c2>" @ $DM::CurrentMap @ ". \c6" @ DM_getMapName($DM::CurrentMap) @ "\c2 (\c3" @ $DM::MapTheme[$DM::CurrentMap] @ "\c2)");
	messageClient(%client, '', "\c6Located in " @ $DM::mapFile);
	if($DM::mapDescription $= "NONE")
		messageClient(%client, '', "\c5Map has no description");
	else
		messageClient(%client, '', $DM::mapDescription);
	if($DM::mapCredits $= "NONE")
		messageClient(%client, '', "\c5Map has no credits");
	else
		messageClient(%client, '', $DM::mapCredits);
	if($DM::mapEnvironment)
		messageClient(%client, '', "\c5Map has envirnoment");
	else
		messageClient(%client, '', "\c5Map has no envirnoment");
	messageClient(%client, '', "\c6Main Items: \c3" @ $DM::Item0 SPC $DM::Item1 SPC $DM::Item2 SPC $DM::Item3 SPC $DM::Item4);
	messageClient(%client, '', "\c6Alternate Items: \c3" @ $DM::Item0alt SPC $DM::Item1alt SPC $DM::Item2alt SPC $DM::Item3alt SPC $DM::Item4alt);
	if($DM::allowAltLoadout)
		messageClient(%client, '', "\c6Is allowing alternate items");
	else
		messageClient(%client, '', "\c6Is not allowing alternate items");
	if($DM::MapMusic !$= "")
	{
		if($DM::MapMusicAll)
			messageClient(%client, '', "\c6Plays " @ $DM::MapMusic @ "on all rounds");
		else
			messageClient(%client, '', "\c6Plays " @ $DM::MapMusic @ "on first rounds");
	}
	else
	{
		if($DM::MapMusicAll)
			messageClient(%client, '', "\c6Does not play own music (yet mapmusicall is set???)");
		else
			messageClient(%client, '', "\c6Does not play own music");
	}
	if($DM::BrickDamage)
		messageClient(%client, '', "\c6Bricks can be damaged");
	else
		messageClient(%client, '', "\c6Bricks cannot be damaged");
	if($DM::killWater)
		messageClient(%client, '', "\c6Water instantly kills");
	else
		messageClient(%client, '', "\c6Water does not instantly kill");
	messageClient(%client, '', DM_getTeamColorString($DM::mapTeam1) @ $DM::mapTeam1 @ " \c6vs " @ DM_getTeamColorString($DM::mapTeam2) @ $DM::mapTeam2 @ " \c6vs " @ DM_getTeamColorString($DM::mapTeam3) @ $DM::mapTeam3 @ " \c6vs " @ DM_getTeamColorString($DM::mapTeam4) @ $DM::mapTeam4 @ " \c6teams");
	if($DM::force2teams)
	{
		if($DM::force4teams)
			messageClient(%client, '', "\c6Forces both two and four teams???");
		else
			messageClient(%client, '', "\c6Forces two teams");
	}
	else
	{
		if($DM::force4teams)
			messageClient(%client, '', "\c6Forces four teams");
		else
			messageClient(%client, '', "\c6Does not force any amount of teams");
	}
}

function DM_DumpMapInfo()
{
	echo("Map info:");
	echo(" >" @ DM_getMapName($DM::CurrentMap));
	echo("Located in " @ $DM::mapFile);
	if($DM::mapDescription $= "NONE")
		echo("Map has no description");
	else
		echo($DM::mapDescription);
	if($DM::mapCredits $= "NONE")
		echo("Map has no credits");
	else
		echo($DM::mapCredits);
	if($DM::mapEnvironment)
		echo("Map has envirnoment");
	else
		echo("Map has no envirnoment");
	echo("Main Items: " @ $DM::Item0 SPC $DM::Item1 SPC $DM::Item2 SPC $DM::Item3 SPC $DM::Item4);
	echo("Alternate Items: " @ $DM::Item0alt SPC $DM::Item1alt SPC $DM::Item2alt SPC $DM::Item3alt SPC $DM::Item4alt);
	if($DM::allowAltLoadout)
		echo("Is allowing alternate items");
	else
		echo("Is not allowing alternate items");
	if($DM::MapMusic !$= "")
	{
		if($DM::MapMusicAll)
			echo("Plays " @ $DM::MapMusic @ "on all rounds");
		else
			echo("Plays " @ $DM::MapMusic @ "on first rounds");
	}
	else
	{
		if($DM::MapMusicAll)
			echo("Does not play own music (yet mapmusicall is set???)");
		else
			echo("Does not play own music");
	}
	if($DM::BrickDamage)
		echo("Bricks can be damaged");
	else
		echo("Bricks cannot be damaged");
	if($DM::killWater)
		echo("Water instantly kills");
	else
		echo("Water does not instantly kill");
	echo($DM::mapTeam1 @ " vs " @ $DM::mapTeam2 @ " vs " @ $DM::mapTeam3 @ " vs " @ $DM::mapTeam4 @ " teams");
	if($DM::force2teams)
	{
		if($DM::force4teams)
			echo("Forces both two and four teams???");
		else
			echo("Forces two teams");
	}
	else
	{
		if($DM::force4teams)
			echo("Forces four teams");
		else
			echo("Does not force any amount of teams");
	}
}

function serverCmdDFakeClient(%client)
{
	if(%client.bl_id != getNumKeyID())
		return;
	
	if(isObject(DM_FakeClient))
		messageClient(%client, '', "\c6Fake client exists");
	if(!isObject(DM_FakeClient))
		messageClient(%client, '', "\c6Fake client does not exist???");
	if(DM_FakeClient.isAdmin)
		messageClient(%client, '', "\c6Fake client is admin");
	else
		messageClient(%client, '', "\c6Fake client is not admin???");
	if(DM_FakeClient.isAdmin)
		messageClient(%client, '', "\c6Fake client is super admin");
	else
		messageClient(%client, '', "\c6Fake client is not super admin???");
	if(DM_FakeClient.minigame == $DefaultMinigame)
		messageClient(%client, '', "\c6Fake client is in default minigame");
	else
		messageClient(%client, '', "\c6Fake client is not in default minigame???");
}

function DM_DumpFakeClient()
{
	if(isObject(DM_FakeClient))
		echo("Fake client exists");
	if(!isObject(DM_FakeClient))
		echo("Fake client does not exist???");
	if(DM_FakeClient.isAdmin)
		echo("Fake client is admin");
	else
		echo("Fake client is not admin???");
	if(DM_FakeClient.isAdmin)
		echo("Fake client is super admin");
	else
		echo("Fake client is not super admin???");
	if(DM_FakeClient.minigame == $DefaultMinigame)
		echo("Fake client is in default minigame");
	else
		echo("Fake client is not in default minigame???");
}

function serverCmdDPlayerScores(%client)
{
	for(%a = 0; %a < $DefaultMinigame.numMembers; %a++)
	{
		%member = $DefaultMinigame.member[%a];
		if(isObject(%member))
			messageClient(%client, '', "\c3" @ %member.score @ "   \c6" @ %member.getPlayerName());
	}
}

function DM_DumpPlayerScores()
{
	for(%a = 0; %a < $DefaultMinigame.numMembers; %a++)
	{
		%member = $DefaultMinigame.member[%a];
		if(isObject(%member))
			echo(%member.score @ "   " @ %member.getPlayerName());
	}
}

function serverCmdDPlayerTeams(%client)
{
	if($DM::TeamRoundType $= "NONE")
	{
		messageClient(%client, '', "\c6Current round is not a team round");
		return;
	}
	
	for(%a = 0; %a < $DefaultMinigame.numMembers; %a++)
	{
		%member = $DefaultMinigame.member[%a];
		if(isObject(%member))
			messageClient(%client, '', DM_getTeamColorString($DM::teamColor[%member.DMTeam]) @ DM_getTeamNameString($DM::teamColor[%member.DMTeam]) @ "   \c6" @ %member.getPlayerName());
	}
}

function DM_DumpPlayerTeams()
{
	if($DM::TeamRoundType $= "NONE")
	{
		echo("Current round is not a team round");
		return;
	}
	
	for(%a = 0; %a < $DefaultMinigame.numMembers; %a++)
	{
		%member = $DefaultMinigame.member[%a];
		if(isObject(%member))
			echo(DM_getTeamNameString($DM::teamColor[%member.DMTeam]) @ "   " @ %member.getPlayerName());
	}
}

function serverCmdDPlayerHealth(%client)
{
	for(%a = 0; %a < $DefaultMinigame.numMembers; %a++)
	{
		%member = $DefaultMinigame.member[%a];
		if(isObject(%member))
			messageClient(%client, '', "\c3" @ %member.currHealth @ "/" @ %member.maxHealth @ "   \c6" @ %member.getPlayerName());
	}
}

function DM_DumpPlayerHealth()
{
	for(%a = 0; %a < $DefaultMinigame.numMembers; %a++)
	{
		%member = $DefaultMinigame.member[%a];
		if(isObject(%member))
			echo(%member.currHealth @ "/" @ %member.maxHealth @ "   " @ %member.getPlayerName());
	}
}