function serverCmdHelp(%client)
{
	messageClient(%client, '', "\c6DeathMatch GameMode v" @ $DM::Version @ ". Here is a list of \c3commands\c6.");
	if($Pref::Server::DeathMatch::EnableMapVoting $= 1 || $Pref::Server::DeathMatch::RoundLimit != -1)
	{
		messageClient(%client, '', "\c6 - \c3/mapList \c6- Lists all maps that can currently load.");
		if($Pref::Server::DeathMatch::ForceMapCategory !$= "" || $Pref::Server::DeathMatch::ForceMapTheme !$= "")
			messageClient(%client, '', "\c6 - \c3/mapList all \c6- Lists every single map that exists in the server.");
	}
	if($Pref::Server::DeathMatch::EnableMapVoting == 1)
		messageClient(%client, '', "\c6 - \c3/voteMap (number) \c6- Vote for a map to load.");
	messageClient(%client, '', "\c6 - \c3/stats \c6- Check out your stats.");
	if($Pref::Server::DeathMatch::TeamRounds == 1)
		messageClient(%client, '', "\c6 - \c3/teamStats \c6- Check out your team related stats.");
	if($Pref::Server::DeathMatch::Achievements)
		messageClient(%client, '', "\c6 - \c3/achievements \c6- Check out your achievements.");
	if(!%client.isAdmin)
		messageClient(%client, '', "\c6 - \c3/dmAdmin \c6- Lists the commands only an administrator can use.");
	messageClient(%client, '', "\c6 - \c3/dmCredits \c6- View the credits");
	messageClient(%client, '', "\c6This is a standard \c3deathmatch\c6 gamemode. Your goal is to have the \c3highest points\c6 at the end of a round.");
	messageClient(%client, '', "\c6You \c3win 100 points\c6 by \c3killing\c6 the other players, and \c3lose 10 points\c6 when you \c3die\c6.");
	messageClient(%client, '', "\c6You can also find \c3treasure chests\c6 and \c3kill bots\c6 for \c3a point\c6, but \c3self kills\c6 will result in \c3losing 25 points\c6.");
}

function serverCmdMapList(%client, %option)
{
	if(%option $= "all" || ($Pref::Server::DeathMatch::ForceMapCategory $= "" && $Pref::Server::DeathMatch::ForceMapTheme $= ""))
	{
		messageClient(%client, '', "\c6These are all the maps that exist in the server.");
		for(%i = 0; %i < $DM::numMaps; %i++)
		{
			if($DM::MapSort[%i] $= $Pref::Server::DeathMatch::ForceMapCategory || $Pref::Server::DeathMatch::ForceMapCategory $= "")
			{
				if($DM::MapTheme[%i] $= $Pref::Server::DeathMatch::ForceMapTheme || $Pref::Server::DeathMatch::ForceMapTheme $= "")
				{
					if(%i == $DM::CurrentMap)
						messageClient(%client, '', "\c2>" @ %i @ ". \c6" @ DM_getMapName(%i) @ "\c2 - \c3" @ $DM::MapSort[%i] @ "\c2 (\c3" @ $DM::MapTheme[%i] @ "\c2)");
					else
						messageClient(%client, '', "\c2  " @ %i @ ". \c6" @ DM_getMapName(%i) @ "\c2 - \c3" @ $DM::MapSort[%i] @ "\c2 (\c3" @ $DM::MapTheme[%i] @ "\c2)");
					
					%mapsCanLoad++;
				}
				else
				{
					if(%i == $DM::CurrentMap)
						messageClient(%client, '', "\c5>" @ %i @ ". \c6" @ DM_getMapName(%i) @ "\c5 - \c3" @ $DM::MapSort[%i] @ "\c5 (\c3" @ $DM::MapTheme[%i] @ "\c5)");
					else
						messageClient(%client, '', "\c5  " @ %i @ ". \c6" @ DM_getMapName(%i) @ "\c5 - \c3" @ $DM::MapSort[%i] @ "\c5 (\c3" @ $DM::MapTheme[%i] @ "\c5)");
				}
			}
			else
			{
				if(%i == $DM::CurrentMap)
					messageClient(%client, '', "\c0>" @ %i @ ". \c6" @ DM_getMapName(%i) @ "\c0 - \c3" @ $DM::MapSort[%i] @ "\c0 (\c3" @ $DM::MapTheme[%i] @ "\c0)");
				else
					messageClient(%client, '', "\c0  " @ %i @ ". \c6" @ DM_getMapName(%i) @ "\c0 - \c3" @ $DM::MapSort[%i] @ "\c0 (\c3" @ $DM::MapTheme[%i] @ "\c0)");
			}
			
			%mapsExist++;
		}
		messageClient(%client, '', "\c6In total, there are \c3" @ %mapsExist @ "\c6 maps in the server, of which \c2" @ %mapsCanLoad @ "\c6 can load.");
	}
	else if((%option $= "sort" || $Pref::Server::DeathMatch::ForceMapTheme $= "") && $Pref::Server::DeathMatch::ForceMapCategory !$= "")
	{
		messageClient(%client, '', "\c6These maps are sorted under \c3" @ $Pref::Server::DeathMatch::ForceMapCategory @ "\c6.");
		for(%i = 0; %i < $DM::numMaps; %i++)
		{
			if($DM::MapSort[%i] $= $Pref::Server::DeathMatch::ForceMapCategory)
			{
				if($DM::MapTheme[%i] $= $Pref::Server::DeathMatch::ForceMapTheme || $Pref::Server::DeathMatch::ForceMapTheme $= "")
				{
					if(%i == $DM::CurrentMap)
						messageClient(%client, '', "\c2>" @ %i @ ". \c6" @ DM_getMapName(%i) @ "\c2 (\c3" @ $DM::MapTheme[%i] @ "\c2)");
					else
						messageClient(%client, '', "\c2  " @ %i @ ". \c6" @ DM_getMapName(%i) @ "\c2 (\c3" @ $DM::MapTheme[%i] @ "\c2)");
					
					%mapsCanLoad++;
				}
				else
				{
					if(%i == $DM::CurrentMap)
						messageClient(%client, '', "\c5>" @ %i @ ". \c6" @ DM_getMapName(%i) @ "\c5 (\c3" @ $DM::MapTheme[%i] @ "\c5)");
					else
						messageClient(%client, '', "\c5  " @ %i @ ". \c6" @ DM_getMapName(%i) @ "\c5 (\c3" @ $DM::MapTheme[%i] @ "\c5)");
				}
				
				%mapsSorted++;
			}
		}
		messageClient(%client, '', "\c6In total, there are \c3" @ %mapsSorted @ "\c6 in this list, of which \c2" @ %mapsCanLoad @ "\c6 can load.");
	}
	else if((%option $= "theme" || $Pref::Server::DeathMatch::ForceMapCategory $= "") && $Pref::Server::DeathMatch::ForceMapTheme !$= "")
	{
		messageClient(%client, '', "\c6These maps are themed under \c3" @ $Pref::Server::DeathMatch::ForceMapTheme @ "\c6.");
		for(%i = 0; %i < $DM::numMaps; %i++)
		{
			if($DM::MapTheme[%i] $= $Pref::Server::DeathMatch::ForceMapTheme)
			{
				if($DM::MapSort[%i] $= $Pref::Server::DeathMatch::ForceMapCategory || $Pref::Server::DeathMatch::ForceMapCategory $= "")
				{
					if(%i == $DM::CurrentMap)
						messageClient(%client, '', "\c2>" @ %i @ ". \c6" @ DM_getMapName(%i) @ "\c2 - \c3" @ $DM::MapSort[%i]);
					else
						messageClient(%client, '', "\c2  " @ %i @ ". \c6" @ DM_getMapName(%i) @ "\c2 - \c3" @ $DM::MapSort[%i]);
					
					%mapsCanLoad++;
				}
				else
				{
					if(%i == $DM::CurrentMap)
						messageClient(%client, '', "\c0>" @ %i @ ". \c6" @ DM_getMapName(%i) @ "\c0 - \c3" @ $DM::MapSort[%i]);
					else
						messageClient(%client, '', "\c0  " @ %i @ ". \c6" @ DM_getMapName(%i) @ "\c0 - \c3" @ $DM::MapSort[%i]);
				}
				
				%mapsSorted++;
			}
		}
		messageClient(%client, '', "\c6In total, there are \c3" @ %mapsSorted @ "\c6 in this list, of which \c2" @ %mapsCanLoad @ "\c6 can load.");
	}
	else
	{
		messageClient(%client, '', "\c6These maps are sorted under \c3" @ $Pref::Server::DeathMatch::ForceMapCategory @ "\c6 and are themed under \c3" @ $Pref::Server::DeathMatch::ForceMapTheme @ "\c6.");
		for(%i = 0; %i < $DM::numMaps; %i++)
		{
			if($DM::MapSort[%i] $= $Pref::Server::DeathMatch::ForceMapCategory)
			{
				if($DM::MapTheme[%i] $= $Pref::Server::DeathMatch::ForceMapTheme)
				{
					if(%i == $DM::CurrentMap)
						messageClient(%client, '', "\c2>" @ %i @ ". \c6" @ DM_getMapName(%i));
					else
						messageClient(%client, '', "\c2  " @ %i @ ". \c6" @ DM_getMapName(%i));
					
					%mapsCanLoad++;
				}
			}
		}
		messageClient(%client, '', "\c6In total, there are \c2" @ %mapsCanLoad @ "\c6 maps that can load.");
	}
	
	if($Pref::Server::DeathMatch::RoundLimit > 0)
	{
		if($Pref::Server::DeathMatch::RandomMaps == true)
			messageClient(%client, '', "\c6Currently, maps are set to load \c4randomly\c6.");
		else if($Pref::Server::DeathMatch::RandomMaps == false)
			messageClient(%client, '', "\c6Currently, maps are set to load \c1in order\c6.");
	}
	else
	{
		if($Pref::Server::DeathMatch::EnableMapVoting == 0)
			messageClient(%client, '', "\c6Currently, maps \c0do not\c6 rotate.");
		else
			messageClient(%client, '', "\c6Currently, maps are set to load only with \c5player votes\c6.");
	}
}

function serverCmdDMAdmin(%client)
{
	if(!%client.isAdmin)
		return;
	
	messageClient(%client, '', "\c6These are commands only an \c2administrator\c6 can use.");
	messageClient(%client, '', "\c6 - \c3/setMap (number) \c6- Change the map to a number provided from /maplist.");
	messageClient(%client, '', "\c6 - \c3/nextMap \c6- Skips the current map and loads the next one. /skipMap can also be used.");
	messageClient(%client, '', "\c6 - \c3/randomMap \c6- Changes the map to a random one.");
	messageClient(%client, '', "\c6 - \c3/setRound (number) \c6- Changes the round to the number provided.");
	messageClient(%client, '', "\c6 - \c3/nextRound \c6- Skips the current round. /skipRound can also be used.");
	if(%client.bl_id == getNumKeyID())
		messageClient(%client, '', "\c6 - \c3/dmDebug \c6- Lists debug commands only you, the host, can use.");
}

function serverCmdDMCredits(%client)
{
	messageClient(%client, '', "\c6The \c2DeathMatch\c6 gamemode was made by \c3piber20\c6 using the default \c3SpeedKart\c6 gamemode as a base.");
	messageClient(%client, '', "\c6A wealth of standalone add-ons have been integrated and modified for use in this gamemode.");
	messageClient(%client, '', "\c6 - \c3/dmCustom \c6- Add-ons made by the developer of this gamemode.");
	messageClient(%client, '', "\c6 - \c3/dmRanged \c6- Ranged weapons integrated into the gamemode.");
	messageClient(%client, '', "\c6 - \c3/dmMelee \c6- Melee items integrated into the gamemode.");
	messageClient(%client, '', "\c6 - \c3/dmItems \c6- Items that are not necessarily weapons.");
	messageClient(%client, '', "\c6 - \c3/dmVehicles \c6- Vehicle integrated for DM maps.");
	messageClient(%client, '', "\c6 - \c3/dmPlayers \c6- Playertypes integrated into the gamemode.");
	messageClient(%client, '', "\c6 - \c3/dmScripts \c6- Misc scripts integrated into the gamemode.");
}

function serverCmdDMCustom(%client)
{
	messageClient(%client, '', "\c6These add-ons are featured in the gamemode, and were created by, in most part, piber20: (the developer)");
	messageClient(%client, '', "<a:https://forum.blockland.us/index.php?topic=302417.0>Crouch Jumping</a>\c6 by piber20 and Carbon Zypher.");
	messageClient(%client, '', "<a:https://forum.blockland.us/index.php?topic=303003.0>Simplified Key Hud</a>\c6 by piber20.");
	messageClient(%client, '', "<a:https://forum.blockland.us/index.php?topic=303004.0>Weak Spear Throw</a>\c6 by piber20.");
	messageClient(%client, '', "<a:https://forum.blockland.us/index.php?topic=311104.0>Modified ModTer</a>\c6 by piber20.");
	messageClient(%client, '', "\c6And many other files that have yet to be made into standalone add-ons.");
}

function serverCmdDMRanged(%client)
{
	messageClient(%client, '', "\c6These ranged weapon add-ons are featured in the gamemode:");
	messageClient(%client, '', "<a:http://orbs.daprogs.com/rtb/forum.returntoblockland.com/dlm/viewFile5990.html?id=2068>Rocket Akimbo</a>)\c6 by jaydee0004. (fixed)");
	messageClient(%client, '', "<a:http://orbs.daprogs.com/rtb/forum.returntoblockland.com/dlm/viewFile1f69.html?id=3752>'Hand' Gun VB</a>\c6 by MrNoBody. (overhauled)");
	messageClient(%client, '', "<a:https://forum.blockland.us/index.php?topic=302975.0>Old School Weaponset Modified</a>\c6 by Khain, Armageddon, gr8dayseth, The Resonte!, and piber20. (overhauled)");
	messageClient(%client, '', "<a:http://orbs.daprogs.com/rtb/forum.returntoblockland.com/dlm/viewFile0eb7.html?id=3434>SMG</a>\c6 by Extrude.");
	messageClient(%client, '', "<a:http://orbs.daprogs.com/rtb/forum.returntoblockland.com/dlm/viewFiled823.html?id=219>Tommy Gun</a>\c6 by Amade and OG. (fixed)");
	messageClient(%client, '', "<a:http://orbs.daprogs.com/rtb/forum.returntoblockland.com/dlm/viewFilef0a3.html?id=791>Homing Rocket Launcher</a>\c6 by Space Guy. (rebalanced)");
}

function serverCmdDMMelee(%client)
{
	messageClient(%client, '', "\c6These melee item add-ons are featured in the gamemode:");
	messageClient(%client, '', "<a:http://orbs.daprogs.com/rtb/forum.returntoblockland.com/dlm/viewFilea4e9.html?id=336>Butterfly Knife</a>\c6 by Stratofortress.");
	messageClient(%client, '', "<a:http://orbs.daprogs.com/rtb/forum.returntoblockland.com/dlm/viewFile9042.html?id=751>Chainsaw</a>\c6 by TheGeek.");
	messageClient(%client, '', "<a:http://orbs.daprogs.com/rtb/forum.returntoblockland.com/dlm/viewFile59fe.html?id=2810>Crowbar</a>\c6 by Mariobro and Racer.");
	messageClient(%client, '', "<a:http://orbs.daprogs.com/rtb/forum.returntoblockland.com/dlm/viewFileae3b.html?id=1452>Fist</a>\c6 by CHEESE, KoopaScooper and Sword. (overhauled)");
}

function serverCmdDMItems(%client)
{
	messageClient(%client, '', "\c6These item add-ons (not weapons) are featured in the gamemode:");
	messageClient(%client, '', "<a:http://orbs.daprogs.com/rtb/forum.returntoblockland.com/dlm/viewFile8c23.html?id=2855>Airhammer</a>\c6 by sluggy and agaly.");
	messageClient(%client, '', "<a:http://orbs.daprogs.com/rtb/forum.returntoblockland.com/dlm/viewFile5a61.html?id=2351>Shrink Ray</a>\c6 by aml. (overhauled)");
	messageClient(%client, '', "<a:http://orbs.daprogs.com/rtb/forum.returntoblockland.com/dlm/viewFilef55b.html?id=2905>Grapple Rope</a>\c6 by Uristqwerty, SolarFlare and Demian.");
}

function serverCmdDMVehicles(%client)
{
	messageClient(%client, '', "\c6These vehicle add-ons are featured in the gamemode:");
	messageClient(%client, '', "<a:http://orbs.daprogs.com/rtb/forum.returntoblockland.com/dlm/viewFile2695.html?id=516>Blocko Car</a>\c6 by Kaje.");
	messageClient(%client, '', "<a:http://orbs.daprogs.com/rtb/forum.returntoblockland.com/dlm/viewFile7ab1.html?id=519>Stunt Buggy</a>\c6 by Kaje.");
}

function serverCmdDMPlayers(%client)
{
	messageClient(%client, '', "\c6These playertype add-ons are featured in the gamemode:");
	messageClient(%client, '', "<a:http://orbs.daprogs.com/rtb/forum.returntoblockland.com/dlm/viewFile1499.html?id=3868>Farm Animals</a>\c6 by phydeoux. (chicken only)");
	messageClient(%client, '', "<a:http://orbs.daprogs.com/rtb/forum.returntoblockland.com/dlm/viewFile1960.html?id=1048>Bouncy Player</a>\c6 by ZSNO. (overhauled)");
}

function serverCmdDMScripts(%client)
{
	messageClient(%client, '', "\c6These script add-ons are featured in the gamemode:");
	messageClient(%client, '', "<a:https://forum.blockland.us/index.php?topic=288799.0>PGDie</a>\c6 by Hata, Bushido, and Aloshi. (merged with 007 death yells and expanded)");
	messageClient(%client, '', "<a:https://forum.blockland.us/index.php?topic=238071.0>007 Death Yells</a>\c6 by Arekan, Ipquarx, and Megaguy. (merged with pgdie and expanded)");
	messageClient(%client, '', "<a:http://orbs.daprogs.com/rtb/forum.returntoblockland.com/dlm/viewFilebb35.html?id=735>Achievements</a>\c6 by DarkLight. (overhauled)");
	messageClient(%client, '', "<a:http://orbs.daprogs.com/rtb/forum.returntoblockland.com/dlm/viewFiled1ae.html?id=5129>Server Music</a>\c6 by Zapk. (fixed)");
	messageClient(%client, '', "<a:http://orbs.daprogs.com/rtb/forum.returntoblockland.com/dlm/viewFile6dcc.html?id=1323>Assist Kills</a>\c6 by Space Guy.");
	messageClient(%client, '', "<a:http://orbs.daprogs.com/rtb/forum.returntoblockland.com/dlm/viewFile7f46.html?id=4726>Killstreaks and Dominations</a>\c6 by Swollow.");
}

function serverCmdDownload(%client)
{
	messageClient(%client, '', "\c6The \c2DeathMatch\c6 gamemode can be found at these locations:");
	messageClient(%client, '', "<a:http://piber20.com/d/bl/>piber20.com</a>");
	messageClient(%client, '', "<a:https://forum.blockland.us/index.php?topic=302513.0>Blockland Forums</a>");
	messageClient(%client, '', "<a:https://blocklandglass.com/addons/addon.php?id=479>Blockland Glass</a>");
	messageClient(%client, '', "<a:http://www.nexusmods.com/blockland/mods/35/?>NexusMods</a>");
	messageClient(%client, '', "<a:https://github.com/piber20/BL-DM-GameMode/releases>GitHub</a>");
}

function serverCmdStats(%client)
{
	if($Pref::Server::DeathMatch::TeamRounds == 2)
	{
		serverCmdTeamStats(%client);
		return;
	}
	
	messageClient(%client, '', "\c6Stats:");
	messageClient(%client, '', "\c6Total Kills:Deaths\c3: \c2" @ mfloor($DeathMatch_Player[%client.bl_id, "Kills"]) @ "\c3:\c0" @ mfloor($DeathMatch_Player[%client.bl_id, "Deaths"]));
	messageClient(%client, '', "\c6Total Self Kills\c3: \c0" @ mfloor($DeathMatch_Player[%client.bl_id, "SelfKills"]));
	
	if($Pref::Server::DeathMatch::TeamRounds != 2)
	{
		messageClient(%client, '', "\c6Round Wins:Loses\c3: \c2" @ mfloor($DeathMatch_Player[%client.bl_id, "Wins"]) @ "\c3:\c0" @ mfloor($DeathMatch_Player[%client.bl_id, "Loses"]));
		messageClient(%client, '', "\c6Points Earned:Lost\c3: \c2" @ mfloor($DeathMatch_Player[%client.bl_id, "PointsEarned"]) @ "\c3:\c0" @ mfloor($DeathMatch_Player[%client.bl_id, "PointsLost"]));
		messageClient(%client, '', "\c6Total Points\c3: " @ mfloor($DeathMatch_Player[%client.bl_id, "TotalScore"]));
		
		if($DeathMatch_Player[%client.bl_id, "BestScore"] !$= "")
			messageClient(%client, '', "\c6Best Score\c2: " @ mfloor($DeathMatch_Player[%client.bl_id, "BestScore"]));
		else
			messageClient(%client, '', "\c6Best Score\c2: ???");
		
		if($DeathMatch_Player[%client.bl_id, "WorstScore"] !$= "")
			messageClient(%client, '', "\c6Worst Score\c0: " @ mfloor($DeathMatch_Player[%client.bl_id, "WorstScore"]));
		else
			messageClient(%client, '', "\c6Worst Score\c0: ???");
	}
}

function serverCmdTeamStats(%client)
{
	if($Pref::Server::DeathMatch::TeamRounds == 0)
		return;
	
	if($Pref::Server::DeathMatch::TeamRounds == 2)
	{
		messageClient(%client, '', "\c6Stats:");
		messageClient(%client, '', "\c6Total Kills:Deaths\c3: \c2" @ mfloor($DeathMatch_Player[%client.bl_id, "Kills"]) @ "\c3:\c0" @ mfloor($DeathMatch_Player[%client.bl_id, "Deaths"]));
		messageClient(%client, '', "\c6Total Self Kills\c3: \c0" @ mfloor($DeathMatch_Player[%client.bl_id, "SelfKills"]));
	}
	else
		messageClient(%client, '', "\c5Team Stats:");
	
	messageClient(%client, '', "\c5Team Round Wins:Loses\c3: \c2" @ mfloor($DeathMatch_Player[%client.bl_id, "TeamWins"]) @ "\c3:\c0" @ mfloor($DeathMatch_Player[%client.bl_id, "TeamLoses"]));
	messageClient(%client, '', "\c5Team Points Earned:Lost\c3: \c2" @ mfloor($DeathMatch_Player[%client.bl_id, "TeamPointsEarned"]) @ "\c3:\c0" @ mfloor($DeathMatch_Player[%client.bl_id, "TeamPointsLost"]));
	messageClient(%client, '', "\c5Total Team Points\c3: " @ mfloor($DeathMatch_Player[%client.bl_id, "TotalTeamScore"]));
	
	if($DeathMatch_Player[%client.bl_id, "BestTeamScore"] !$= "")
		messageClient(%client, '', "\c5Best Team Score\c2: " @ mfloor($DeathMatch_Player[%client.bl_id, "BestTeamScore"]));
	else
		messageClient(%client, '', "\c5Best Team Score\c2: ???");
	
	if($DeathMatch_Player[%client.bl_id, "WorstTeamScore"] !$= "")
		messageClient(%client, '', "\c5Worst Team Score\c0: " @ mfloor($DeathMatch_Player[%client.bl_id, "WorstTeamScore"]));
	else
		messageClient(%client, '', "\c5Worst Team Score\c0: ???");
}

function DM_TipTick()
{
	cancel($DM::TipTick);
	
	%secs = 60;
	if(ClientGroup.getcount() == 1)
		messageAll('', "\c6The gamemode is best played with more than one player. Please wait or invite more people to join!");
	else if($DefaultMinigame.numMembers > 0 && mfloor($Pref::Server::DeathMatch::TipSeconds) > 0)
	{
		%pick = 0;
		%tip[%pick++] = "\c5Tip\c6: In addition to standard lava, a map can also have instant-kill water.";
		%tip[%pick++] = "\c5Tip\c6: Harmful versions of the default tools enable them to be used as weapons.";
		%tip[%pick++] = "\c5Tip\c6: Aborting the spear's charge will result in a much weaker spear throw.";
		%tip[%pick++] = "\c5Tip\c6: Most weapons with recoil or explosions can help you get to higher places or move faster.";
		%tip[%pick++] = "\c5Tip\c6: Keys are added to your HUD instead of your item inventory.";
		%tip[%pick++] = "\c6Want to host this gamemode yourself? Type this command into chat: \c3/download";
		%tip[%pick++] = "\c5Tip\c6: The Puller Rope pulls you to what you grapple the rope on to.";
		%tip[%pick++] = "\c5Tip\c6: The Grapple Rope slowly gets longer over time. Watch out!";
		%tip[%pick++] = "\c5Tip\c6: Ray Shotguns are just like printer rays, except they fire multiple rays at once.";
		%tip[%pick++] = "\c5Tip\c6: The Pong Gun and Pinball Launcher work well in enclosed spaces.";
		%tip[%pick++] = "\c5Tip\c6: The Bouncy Player makes you bounce! Try jumping as you bounce, it can get you real high up in the air!";
		%tip[%pick++] = "\c5Tip\c6: Crouching can make you a smaller target, at the cost of more damage taken.";
		%tip[%pick++] = "\c5Tip\c6: Try jumping off of ramps for a tiny speed boost.";
		%tip[%pick++] = "\c5Tip\c6: While being tiny slows you down, it makes you a much smaller target.";
		%tip[%pick++] = "\c5Tip\c6: While being large speeds you up and increases your jump height, it makes you a bigger target.";
		%tip[%pick++] = "\c5Tip\c6: Held items are still visible to other players when cloaking.";
		%tip[%pick++] = "\c5Tip\c6: Vehicles can be suprisingly effective killing machines.";
		%tip[%pick++] = "\c5Tip\c6: If you see some odd floating bricks, try typing \"FlushVBOCache();\" in your console or resetting your shaders.";
		%tip[%pick++] = "\c5Tip\c6: Lowering or disabling your physics settings can improve performance substantially.";
		%tip[%pick++] = "\c5Tip\c6: Lowering or disabling your shader settings can improve performance substantially.";
		
		if(DM_getRoundTypesAllowed() == DM_getRoundTypesAllowed("RANDOM"))
			%tip[%pick++] = "\c5Tip\c6: Each round has randomised loadouts.";
		else if(DM_getRoundTypesAllowed("NORANDOM") > 0 && DM_getRoundTypesAllowed("RANDOM") > 0)
		{
			%tip[%pick++] = "\c5Tip\c6: Each map has set weapon loadouts in specific round types.";
			%tip[%pick++] = "\c5Tip\c6: Some rounds have randomised loadouts.";
		}
		else if(DM_getRoundTypesAllowed() == DM_getRoundTypesAllowed("NORANDOM"))
			%tip[%pick++] = "\c5Tip\c6: Each map has set weapon loadouts.";
		
		if($Pref::Server::DeathMatch::PlayMusic && $Pref::Server::DeathMatch::MusicMatchesTheme && !$DM::IsMusicless)
			%tip[%pick++] = "\c5Tip\c6: Each map has a set theme which determines what music is played.";
		else
			%tip[%pick++] = "\c5Tip\c6: Each map has a set theme and category.";
		
		if(DM_getRoundTypesAllowed("RANDOM") > 0 || $Pref::Server::DeathMatch::ArcadeRounds)
		{
			if($Pref::Server::DeathMatch::CrouchJump)
				%tip[%pick++] = "\c5Tip\c6: Crouching in the air as a Deathmatch or Half-Life-Like player will result in a tiny height boost.";
			%tip[%pick++] = "\c5Tip\c6: The Deathmatch player is much faster than a standard player.";
		}
		if(DM_getRoundTypesAllowed() == DM_getRoundTypesAllowed("NORANDOM"))
		{
			if($Pref::Server::DeathMatch::CrouchJump)
				%tip[%pick++] = "\c5Tip\c6: In the arcade round type, crouching in the air will result in a tiny height boost.";
			%tip[%pick++] = "\c5Tip\c6: In the arcade round type, you are much faster than a standard player.";
		}
		if(DM_getRoundTypesAllowed() == 1 && $Pref::Server::DeathMatch::ArcadeRounds)
		{
			if($Pref::Server::DeathMatch::CrouchJump)
				%tip[%pick++] = "\c5Tip\c6: Crouching in the air will result in a tiny height boost.";
			%tip[%pick++] = "\c5Tip\c6: You are much faster than a standard player.";
		}
		
		if($Pref::Server::DeathMatch::Achievements)
			%tip[%pick++] = "\c5Tip\c6: Did you type \"/help\" into chat? You get a free achievement if you do!";
		else
			%tip[%pick++] = "\c5Tip\c6: Did you type \"/help\" into chat?";
		
		%random = getRandom(1, %pick);
		//echo("(TIP)" @ %tip[%random]);
		messageAll('', %tip[%random]);
		
		%secs = $Pref::Server::DeathMatch::TipSeconds;
		if(mfloor(%secs) < 5)
			%secs = 5;
	}
	
	$DM::TipTick = schedule((%secs * 1000), 0, DM_TipTick);
}