function GameConnection::DM_ApplyTeam(%this)
{
	if($DM::TeamRoundType !$= "NONE")
	{
		if(%this.DMTeam == 0)
		{
			if($DM::TeamRoundType $= "4TEAMS")
			{
				%team = getRandom(1, 4);
				if($DefaultMinigame.numMembers > 3)
				{
					%quarterMembers = $DefaultMinigame.numMembers / 4;
					%quarterMembers = mceil(%quarterMembers);
					if($DM::TeamPlayers[%team] >= %quarterMembers)
						%team++;
					if(%team > 4)
						%team = 1;
				}
				else if($DefaultMinigame.numMembers > 1)
				{
					if($DM::TeamPlayers[%team] >= 1)
						%team++;
					if(%team > 4)
						%team = 1;
				}
			}
			else
			{
				%team = getRandom(1, 2);
				if($DefaultMinigame.numMembers > 1)
				{
					%halfMembers = $DefaultMinigame.numMembers / 2;
					%halfMembers = mfloor(%halfMembers);
					if($DM::TeamPlayers[%team] >= %halfMembers)
						%team++;
					if(%team > 2)
						%team = 1;
				}
			}
			
			%this.DMTeam = %team;
			%this.setScore($DM::TeamScore[%this.DMTeam]);
			$DM::TeamPlayers[%team]++;
		}
		
		%player = %this.player;
		if(%this.DMTeam > 0 && isObject(%player))
			%player.setShapeNameColor(DM_getTeamShapeNameColor($DM::teamColor[%this.DMTeam]));
	}
	else
		%this.DMTeam = 0;
}

function DM_isValidTeam(%team)
{
	if(%team $= "RED" ||
	   %team $= "BLUE" ||
	   %team $= "GREEN" ||
	   %team $= "YELLOW" ||
	   %team $= "CYAN" ||
	   %team $= "MAGENTA" ||
	   %team $= "WHITE" ||
	   %team $= "BLACK" ||
	   %team $= "ORANGE" ||
	   %team $= "BROWN" ||
	   %team $= "PURPLE" ||
	   %team $= "PINK")
		return true;
	else
		return false;
}

function DM_getTeamShapeNameColor(%team)
{
	if(%team $= "RED")
		return "1 0 0 1";
	else if(%team $= "BLUE")
		return "0 0 1 1";
	else if(%team $= "GREEN")
		return "0 1 0 1";
	else if(%team $= "YELLOW")
		return "1 1 0 1";
	else if(%team $= "CYAN")
		return "0 1 1 1";
	else if(%team $= "MAGENTA")
		return "1 0 1 1";
	else if(%team $= "WHITE")
		return "1 1 1 1";
	else if(%team $= "BLACK")
		return "0.5 0.5 0.5 1";
	else if(%team $= "ORANGE")
		return "1 0.5 0 1";
	else if(%team $= "BROWN")
		return "0.5 0.25 0 1";
	else if(%team $= "PURPLE")
		return "0.5 0 0.5 1";
	else if(%team $= "PINK")
		return "1 0.5 1 1";
	else
	{
		error("Tried to get shape name color for invalid team '" @ %team @ "'");
		return "0 0 0 0";
	}
}

function DM_getTeamNameString(%team)
{
	if(%team $= "RED")
		return "Red";
	else if(%team $= "BLUE")
		return "Blue";
	else if(%team $= "GREEN")
		return "Green";
	else if(%team $= "YELLOW")
		return "Yellow";
	else if(%team $= "CYAN")
		return "Cyan";
	else if(%team $= "MAGENTA")
		return "Magenta";
	else if(%team $= "WHITE")
		return "White";
	else if(%team $= "BLACK")
		return "Black";
	else if(%team $= "ORANGE")
		return "Orange";
	else if(%team $= "BROWN")
		return "Brown";
	else if(%team $= "PURPLE")
		return "Purple";
	else if(%team $= "PINK")
		return "Pink";
	else
	{
		error("Tried to get name string for invalid team '" @ %team @ "'");
		return "Unknown";
	}
}

function DM_getTeamColorString(%team)
{
	if(%team $= "RED")
		return "\c0";
	else if(%team $= "BLUE")
		return "\c1";
	else if(%team $= "GREEN")
		return "\c2";
	else if(%team $= "YELLOW")
		return "\c3";
	else if(%team $= "CYAN")
		return "\c4";
	else if(%team $= "MAGENTA")
		return "\c5";
	else if(%team $= "WHITE")
		return "\c6";
	else if(%team $= "BLACK")
		return "\c7";
	else if(%team $= "ORANGE")
		return "<color:ff6600>";
	else if(%team $= "BROWN")
		return "<color:995500>";
	else if(%team $= "PURPLE")
		return "<color:990099>";
	else if(%team $= "PINK")
		return "<color:ff99ff>";
	else
	{
		error("Tried to get color string for invalid team '" @ %team @ "'");
		return "ColorError";
	}
}

function DM_getTeamsActive()
{
	%teams = 0;
	
	if($DM::TeamPlayers1 > 0)
		%teams++;
	if($DM::TeamPlayers2 > 0)
		%teams++;
	if($DM::TeamPlayers3 > 0)
		%teams++;
	if($DM::TeamPlayers4 > 0)
		%teams++;
	
	return %teams;
}

function DM_getRandomTeam(%no1, %no2, %no3)
{
	%no1 = mfloor(%no1);
	%no2 = mfloor(%no2);
	%no3 = mfloor(%no3);
	%isNo = 0;
	if(%no1 > 0)
		%isNo++;
	else
		%no1 = 99;
	if(%no2 > 0)
		%isNo++;
	else
		%no2 = 99;
	if(%no3 > 0)
		%isNo++;
	else
		%no3 = 99;
	
	%random = getRandom(1, 12 - %isNo);
	
	if(%random >= %no1)
		%random++;
	if(%random >= %no2)
		%random++;
	if(%random >= %no3)
		%random++;
	
	if(%random > 12)
	{
		%random -= 12;
		
		if(%random == %no1)
			%random++;
		if(%random == %no2)
			%random++;
		if(%random == %no3)
			%random++;
	}
	
	%a = 0;
	%team[%a++] = "RED";
	%team[%a++] = "BLUE";
	%team[%a++] = "GREEN";
	%team[%a++] = "YELLOW";
	%team[%a++] = "CYAN";
	%team[%a++] = "MAGENTA";
	%team[%a++] = "WHITE";
	%team[%a++] = "BLACK";
	%team[%a++] = "ORANGE";
	%team[%a++] = "BROWN";
	%team[%a++] = "PURPLE";
	%team[%a++] = "PINK";
	
	return %team[%random];
}

function DM_teamColorToNumber(%team)
{
	if(%team $= "RED")
		return 1;
	else if(%team $= "BLUE")
		return 2;
	else if(%team $= "GREEN")
		return 3;
	else if(%team $= "YELLOW")
		return 4;
	else if(%team $= "CYAN")
		return 5;
	else if(%team $= "MAGENTA")
		return 6;
	else if(%team $= "WHITE")
		return 7;
	else if(%team $= "BLACK")
		return 8;
	else if(%team $= "ORANGE")
		return 9;
	else if(%team $= "BROWN")
		return 10;
	else if(%team $= "PURPLE")
		return 11;
	else if(%team $= "PINK")
		return 12;
	else
	{
		error("Tried to get team color number for invalid team '" @ %team @ "'");
		return 0;
	}
}

function serverCmdTeamList(%client)
{
	echo("");
	
	messageClient(%client, '', "\c6Valid teams:");
	messageClient(%client, '', "\c0RED");
	messageClient(%client, '', "\c1BLUE");
	messageClient(%client, '', "\c2GREEN");
	messageClient(%client, '', "\c3YELLOW");
	messageClient(%client, '', "\c4CYAN");
	messageClient(%client, '', "\c5MAGENTA");
	messageClient(%client, '', "\c6WHITE");
	messageClient(%client, '', "\c7BLACK");
	messageClient(%client, '', "<color:ff6600>ORANGE");
	messageClient(%client, '', "<color:995500>BROWN");
	messageClient(%client, '', "<color:990099>PURPLE");
	messageClient(%client, '', "<color:ff99ff>PINK");
	
	echo("");
}