if($GameModeArg !$= "Add-Ons/GameMode_DeathMatch/gamemode.txt" )
{
	error("Error: GameMode_DeathMatch cannot be used in custom games");
	return;
}

function DM_LoadPrefs()
{
	///////////////
	//ROUND PREFS//
	///////////////
	
	//rounds per map
	if($Pref::Server::DeathMatch::RoundLimit $= "")
		$Pref::Server::DeathMatch::RoundLimit = 3;
	
	//seconds per round
	if($Pref::Server::DeathMatch::TimeLimit $= "")
		$Pref::Server::DeathMatch::TimeLimit = 180;
	
	//allow arcade rounds
	if($Pref::Server::DeathMatch::ArcadeRounds $= "")
		$Pref::Server::DeathMatch::ArcadeRounds = true;
	
	//allow classic rounds
	if($Pref::Server::DeathMatch::ClassicRounds $= "")
		$Pref::Server::DeathMatch::ClassicRounds = false;
	
	//allow randomised rounds
	if($Pref::Server::DeathMatch::RandomisedRounds $= "")
		$Pref::Server::DeathMatch::RandomisedRounds = false;
	
	//allow random balance rounds
	if($Pref::Server::DeathMatch::RandomBalanceRounds $= "")
		$Pref::Server::DeathMatch::RandomBalanceRounds = false;
	
	//allow random melee rounds
	if($Pref::Server::DeathMatch::RandomMeleeRounds $= "")
		$Pref::Server::DeathMatch::RandomMeleeRounds = false;
	
	/////////////
	//MAP PREFS//
	/////////////
	
	//true to load maps in random order, false to load them in numbered order
	if($Pref::Server::DeathMatch::RandomMaps $= "")
		$Pref::Server::DeathMatch::RandomMaps = false;
	
	//only allow maps with the provided theme to load
	if($Pref::Server::DeathMatch::ForceMapTheme $= "")
		$Pref::Server::DeathMatch::ForceMapTheme = "";
	
	//only allow maps with the provided category to load
	if($Pref::Server::DeathMatch::ForceMapCategory $= "")
		$Pref::Server::DeathMatch::ForceMapCategory = "";
	
	//allow players to vote for maps
	if($Pref::Server::DeathMatch::EnableMapVoting $= "")
		$Pref::Server::DeathMatch::EnableMapVoting = 1;
	
	//////////////
	//TEAM PREFS//
	//////////////
	
	//enable team rounds
	if($Pref::Server::DeathMatch::TeamRounds $= "")
		$Pref::Server::DeathMatch::TeamRounds = 1;
	
	//enable team chat
	if($Pref::Server::DeathMatch::TeamChat $= "")
		$Pref::Server::DeathMatch::TeamChat = true;
	
	//enable team-specific spawns
	if($Pref::Server::DeathMatch::TeamSpawns $= "")
		$Pref::Server::DeathMatch::TeamSpawns = true;
	
	//1 out of X chance to randomise a team color (-1 disables)
	if($Pref::Server::DeathMatch::RandomTeamColors $= "")
		$Pref::Server::DeathMatch::RandomTeamColors = -1;
	
	///////////////
	//MUSIC PREFS//
	///////////////
	
	//play music
	if($Pref::Server::DeathMatch::PlayMusic $= "")
		$Pref::Server::DeathMatch::PlayMusic = true;
	
	//only play music that matches the map's theme
	if($Pref::Server::DeathMatch::MusicMatchesTheme $= "")
		$Pref::Server::DeathMatch::MusicMatchesTheme = true;
	
	/////////////
	//TIP PREFS//
	/////////////
	
	//display a tip every X seconds (-1 disables)
	if($Pref::Server::DeathMatch::TipSeconds $= "")
		$Pref::Server::DeathMatch::TipSeconds = 60;
	
	//////////////////
	//GAMEPLAY PREFS//
	//////////////////
	
	//enable achievements system
	if($Pref::Server::DeathMatch::Achievements $= "")
		$Pref::Server::DeathMatch::Achievements = true;
	
	//display achievement in chat
	if($Pref::Server::DeathMatch::AchievementsChatMsg $= "")
		$Pref::Server::DeathMatch::AchievementsChatMsg = false;
	
	//enable crouch jumping
	if($Pref::Server::DeathMatch::CrouchJump $= "")
		$Pref::Server::DeathMatch::CrouchJump = true;
	
	//check in air every X miliseconds
	if($Pref::Server::DeathMatch::CrouchJumpTick $= "")
		$Pref::Server::DeathMatch::CrouchJumpTick = 100;
	
	//enable kill streaks system
	if($Pref::Server::DeathMatch::Killstreaks $= "")
		$Pref::Server::DeathMatch::Killstreaks = true;
	
	//display kill streak in chat
	if($Pref::Server::DeathMatch::KillstreaksChatMsg $= "")
		$Pref::Server::DeathMatch::KillstreaksChatMsg = false;
	
	///////////////
	//DEATH PREFS//
	///////////////
	
	//crumble players on death
	if($Pref::Server::DeathMatch::CrumbleDeath $= "")
		$Pref::Server::DeathMatch::CrumbleDeath = true;
	
	//do special emitter effects on death
	if($Pref::Server::DeathMatch::PGDieEffects $= "")
		$Pref::Server::DeathMatch::PGDieEffects = true;
	
	//play gag sounds on death
	if($Pref::Server::DeathMatch::PGDieSounds $= "")
		$Pref::Server::DeathMatch::PGDieSounds = true;
	
	//play a random yell on death
	if($Pref::Server::DeathMatch::RandomDeathYells $= "")
		$Pref::Server::DeathMatch::RandomDeathYells = true;
	
	/////////////////
	//LOADOUT PREFS//
	/////////////////
	
	//give the old school weapons their old color scheme
	if($Pref::Server::DeathMatch::ColorfulOldSchoolWeapons $= "")
		$Pref::Server::DeathMatch::ColorfulOldSchoolWeapons = false;
	
	//allow players to spawn with kits
	if($Pref::Server::DeathMatch::RandomisedKits $= "")
		$Pref::Server::DeathMatch::RandomisedKits = true;
	
	//allow players to spawn with printer rays
	if($Pref::Server::DeathMatch::RandomisedPrinterRays $= "")
		$Pref::Server::DeathMatch::RandomisedPrinterRays = true;
	
	//allow players to spawn with shotgun rays
	if($Pref::Server::DeathMatch::RandomisedShotgunRays $= "")
		$Pref::Server::DeathMatch::RandomisedShotgunRays = true;
	
	///////////////
	//ADDON PREFS//
	///////////////
	
	//custom music path
	if($Pref::Server::DeathMatch::CustomMusicPath $= "")
		$Pref::Server::DeathMatch::CustomMusicPath = "Add-Ons/Music/";
	
	//addons to load after gamemode execution, only works with addons that have a server.cs, and that's executed directly.
	if($Pref::Server::DeathMatch::LoadAddon1 $= "")
		$Pref::Server::DeathMatch::LoadAddon1 = "";
	
	if($Pref::Server::DeathMatch::LoadAddon2 $= "")
		$Pref::Server::DeathMatch::LoadAddon2 = "";
	
	if($Pref::Server::DeathMatch::LoadAddon3 $= "")
		$Pref::Server::DeathMatch::LoadAddon3 = "";
	
	if($Pref::Server::DeathMatch::LoadAddon4 $= "")
		$Pref::Server::DeathMatch::LoadAddon4 = "";
	
	if($Pref::Server::DeathMatch::LoadAddon5 $= "")
		$Pref::Server::DeathMatch::LoadAddon5 = "";
	
	if($Pref::Server::DeathMatch::LoadAddon6 $= "")
		$Pref::Server::DeathMatch::LoadAddon6 = "";
	
	if($Pref::Server::DeathMatch::LoadAddon7 $= "")
		$Pref::Server::DeathMatch::LoadAddon7 = "";
	
	if($Pref::Server::DeathMatch::LoadAddon8 $= "")
		$Pref::Server::DeathMatch::LoadAddon8 = "";
	
	if($Pref::Server::DeathMatch::LoadAddon9 $= "")
		$Pref::Server::DeathMatch::LoadAddon9 = "";
	
	if($Pref::Server::DeathMatch::LoadAddon10 $= "")
		$Pref::Server::DeathMatch::LoadAddon10 = "";
	
	//meta
	$DM::Version = 25;
	$DM::IsMusicless = false;
}

function DM_RegisterRTBPrefs()
{
	RTB_registerPref("Rounds per map (-1 disables)",	"DeathMatch GameMode - Rounds",	"$Pref::Server::DeathMatch::RoundLimit",			"int -1 9999",	"GameMode_DeathMatch",	3,		false,	false,	false);
	RTB_registerPref("Seconds per round",				"DeathMatch GameMode - Rounds",	"$Pref::Server::DeathMatch::TimeLimit",				"int 1 99999",	"GameMode_DeathMatch",	240,	false,	false,	false);
	RTB_registerPref("Allow Arcade round type",			"DeathMatch GameMode - Rounds",	"$Pref::Server::DeathMatch::ArcadeRounds",			"bool",			"GameMode_DeathMatch",	true,	false,	false,	false);
	RTB_registerPref("Allow Classic round type",		"DeathMatch GameMode - Rounds",	"$Pref::Server::DeathMatch::ClassicRounds",			"bool",			"GameMode_DeathMatch",	false,	false,	false,	false);
	RTB_registerPref("Allow Randomised round type",		"DeathMatch GameMode - Rounds",	"$Pref::Server::DeathMatch::RandomisedRounds",		"bool",			"GameMode_DeathMatch",	false,	false,	false,	false);
	RTB_registerPref("Allow Random Balance round type",	"DeathMatch GameMode - Rounds",	"$Pref::Server::DeathMatch::RandomBalanceRounds",	"bool",			"GameMode_DeathMatch",	false,	false,	false,	false);
	RTB_registerPref("Allow Random Melee round type",	"DeathMatch GameMode - Rounds",	"$Pref::Server::DeathMatch::RandomMeleeRounds",		"bool",			"GameMode_DeathMatch",	false,	false,	false,	false);
	
	RTB_registerPref("Load maps in random order",		"DeathMatch GameMode - Maps",	"$Pref::Server::DeathMatch::RandomMaps",		"bool",									"GameMode_DeathMatch",	false,	false,	false,	false);
	RTB_registerPref("Force maps with this theme",		"DeathMatch GameMode - Maps",	"$Pref::Server::DeathMatch::ForceMapTheme",		"string 200",							"GameMode_DeathMatch",	"",		false,	false,	false);
	RTB_registerPref("Force maps with this category",	"DeathMatch GameMode - Maps",	"$Pref::Server::DeathMatch::ForceMapCategory",	"string 200",							"GameMode_DeathMatch",	"",		false,	false,	false);
	RTB_registerPref("Allow player map voting",			"DeathMatch GameMode - Maps",	"$Pref::Server::DeathMatch::EnableMapVoting",	"list Disallow 0 Allow 1 Round_Only 2",	"GameMode_DeathMatch",	0,		false,	false,	false);
	
	RTB_registerPref("Allow team rounds",						"DeathMatch GameMode - Teams",	"$Pref::Server::DeathMatch::TeamRounds",		"list Disallow 0 Allow 1 Force 2",	"GameMode_DeathMatch",	1,	false,	false,	false);
	RTB_registerPref("Allow team chat",							"DeathMatch GameMode - Teams",	"$Pref::Server::DeathMatch::TeamChat",			"bool",								"GameMode_DeathMatch",	1,	false,	false,	false);
	RTB_registerPref("Allow team-specific spawns",				"DeathMatch GameMode - Teams",	"$Pref::Server::DeathMatch::TeamSpawns",		"bool",								"GameMode_DeathMatch",	1,	false,	false,	false);
	RTB_registerPref("1/X chance random color (-1 disables)",	"DeathMatch GameMode - Teams",	"$Pref::Server::DeathMatch::RandomTeamColors",	"int -1 20",						"GameMode_DeathMatch",	-1,	false,	false,	false);
	
	RTB_registerPref("Play music",								"DeathMatch GameMode - Music",	"$Pref::Server::DeathMatch::PlayMusic",			"bool",	"GameMode_DeathMatch",	true,	false,	false,	false);
	RTB_registerPref("Choose based on map theme",				"DeathMatch GameMode - Music",	"$Pref::Server::DeathMatch::MusicMatchesTheme",	"bool",	"GameMode_DeathMatch",	true,	false,	false,	false);
	
	RTB_registerPref("Show tip every X seconds (-1 disables)",	"DeathMatch GameMode - Tips",	"$Pref::Server::DeathMatch::TipSeconds",	"int -1 99999",	"GameMode_DeathMatch",	60,	false,	false,	false);
	
	RTB_registerPref("Enable achievements system",					"DeathMatch GameMode - Gameplay",	"$Pref::Server::DeathMatch::Achievements",				"bool",			"GameMode_DeathMatch",	true,	false,	false,	false);
	RTB_registerPref("Show achievements in chat",					"DeathMatch GameMode - Gameplay",	"$Pref::Server::DeathMatch::AchievementsChatMsg",		"bool",			"GameMode_DeathMatch",	false,	false,	false,	false);
	RTB_registerPref("Enable crouch jumping system",				"DeathMatch GameMode - Gameplay",	"$Pref::Server::DeathMatch::CrouchJump",				"bool",			"GameMode_DeathMatch",	true,	false,	false,	false);
	RTB_registerPref("Crouch jump accuracy (lower=better+laggier)",	"DeathMatch GameMode - Gameplay",	"$Pref::Server::DeathMatch::CrouchJumpTick",			"int 1 200",	"GameMode_DeathMatch",	100,	false,	false,	false);
	RTB_registerPref("Enable killstreaks",							"DeathMatch GameMode - Gameplay",	"$Pref::Server::DeathMatch::Killstreaks",				"bool",			"GameMode_DeathMatch",	true,	false,	false,	false);
	RTB_registerPref("Show killstreaks in chat",					"DeathMatch GameMode - Gameplay",	"$Pref::Server::DeathMatch::KillstreaksChatMsg",		"bool",			"GameMode_DeathMatch",	false,	false,	false,	false);
	
	RTB_registerPref("Enable crumble death effect",	"DeathMatch GameMode - Death Effects",	"$Pref::Server::DeathMatch::CrumbleDeath",		"bool",	"GameMode_DeathMatch",	true,	false,	false,	false);
	RTB_registerPref("Enable PGDie death effects",	"DeathMatch GameMode - Death Effects",	"$Pref::Server::DeathMatch::PGDieEffects",		"bool",	"GameMode_DeathMatch",	true,	false,	false,	false);
	RTB_registerPref("Enable PGDie death sounds",	"DeathMatch GameMode - Death Effects",	"$Pref::Server::DeathMatch::PGDieSounds",		"bool",	"GameMode_DeathMatch",	true,	false,	false,	false);
	RTB_registerPref("Enable random death yells",	"DeathMatch GameMode - Death Effects",	"$Pref::Server::DeathMatch::RandomDeathYells",	"bool",	"GameMode_DeathMatch",	true,	false,	false,	false);
	
	RTB_registerPref("Enable colorful old school weapons",			"DeathMatch GameMode - Loadout",	"$Pref::Server::DeathMatch::ColorfulOldSchoolWeapons",	"bool",	"GameMode_DeathMatch",	false,	true,	false,	false);
	RTB_registerPref("Give players kits in random rounds",			"DeathMatch GameMode - Loadout",	"$Pref::Server::DeathMatch::RandomisedKits",			"bool",	"GameMode_DeathMatch",	true,	true,	false,	false);
	RTB_registerPref("Give players printer rays in random rounds",	"DeathMatch GameMode - Loadout",	"$Pref::Server::DeathMatch::RandomisedPrinterRays",		"bool",	"GameMode_DeathMatch",	true,	true,	false,	false);
	RTB_registerPref("Give players shotgun rays in random rounds",	"DeathMatch GameMode - Loadout",	"$Pref::Server::DeathMatch::RandomisedShotgunRays",		"bool",	"GameMode_DeathMatch",	true,	true,	false,	false);
	
	RTB_registerPref("Load music from this file path",	"DeathMatch GameMode - AddOns (advanced users only)",	"$Pref::Server::DeathMatch::CustomMusicPath",	"string 200",	"GameMode_DeathMatch",	"Add-Ons/Music/",	true,	false,	false);
	RTB_registerPref("First add-on to load",			"DeathMatch GameMode - AddOns (advanced users only)",	"$Pref::Server::DeathMatch::LoadAddon1",		"string 200",	"GameMode_DeathMatch",	"",					true,	false,	false);
	RTB_registerPref("Second add-on to load",			"DeathMatch GameMode - AddOns (advanced users only)",	"$Pref::Server::DeathMatch::LoadAddon2",		"string 200",	"GameMode_DeathMatch",	"",					true,	false,	false);
	RTB_registerPref("Third add-on to load",			"DeathMatch GameMode - AddOns (advanced users only)",	"$Pref::Server::DeathMatch::LoadAddon3",		"string 200",	"GameMode_DeathMatch",	"",					true,	false,	false);
	RTB_registerPref("Fourth add-on to load",			"DeathMatch GameMode - AddOns (advanced users only)",	"$Pref::Server::DeathMatch::LoadAddon4",		"string 200",	"GameMode_DeathMatch",	"",					true,	false,	false);
	RTB_registerPref("Fifth add-on to load",			"DeathMatch GameMode - AddOns (advanced users only)",	"$Pref::Server::DeathMatch::LoadAddon5",		"string 200",	"GameMode_DeathMatch",	"",					true,	false,	false);
	RTB_registerPref("Sixth add-on to load",			"DeathMatch GameMode - AddOns (advanced users only)",	"$Pref::Server::DeathMatch::LoadAddon6",		"string 200",	"GameMode_DeathMatch",	"",					true,	false,	false);
	RTB_registerPref("Seventh add-on to load",			"DeathMatch GameMode - AddOns (advanced users only)",	"$Pref::Server::DeathMatch::LoadAddon7",		"string 200",	"GameMode_DeathMatch",	"",					true,	false,	false);
	RTB_registerPref("Eighth add-on to load",			"DeathMatch GameMode - AddOns (advanced users only)",	"$Pref::Server::DeathMatch::LoadAddon8",		"string 200",	"GameMode_DeathMatch",	"",					true,	false,	false);
	RTB_registerPref("Ninth add-on to load",			"DeathMatch GameMode - AddOns (advanced users only)",	"$Pref::Server::DeathMatch::LoadAddon9",		"string 200",	"GameMode_DeathMatch",	"",					true,	false,	false);
	RTB_registerPref("Tenth add-on to load",			"DeathMatch GameMode - AddOns (advanced users only)",	"$Pref::Server::DeathMatch::LoadAddon10",		"string 200",	"GameMode_DeathMatch",	"",					true,	false,	false);
}

if(!$DM::HasExecutedOnce)
{
	echo("Starting up DM Gamemode...");
	DM_LoadPrefs();
	echo("Version: " @ $DM::Version);
	echo("Is Musicless Version: " @ $DM::IsMusicless);
	echo("");
	
	echo("=== Executing add-ons manually that the host might have ===");
	
	if(isFile("Add-Ons/Tool_NewDuplicator/server.cs"))
		exec("Add-Ons/Tool_NewDuplicator/server.cs");
	else
		warn("Tool_NewDuplicator was not found");
	
	echo("");
	
	echo("=== Executing integrated DeathMatch add-ons ===");
	exec("./addons/main.cs");
	echo("");
	
	echo("=== Executing custom made DeathMatch add-ons ===");
	exec("./custom/main.cs");
	echo("");
}

echo("=== Executing DeathMatch core files ===");
exec("./core/main.cs");
echo("");
echo("=== Finished executing DeathMatch files ===");
echo("");

if(!$DM::HasExecutedOnce)
{
	echo("=== Executing add-ons that the host wanted ===");
	
	if($Pref::Server::DeathMatch::LoadAddon1 !$= "" && isFile("Add-Ons/" @ $Pref::Server::DeathMatch::LoadAddon1 @ "/server.cs"))
		exec("Add-Ons/" @ $Pref::Server::DeathMatch::LoadAddon1 @ "/server.cs");
	
	if($Pref::Server::DeathMatch::LoadAddon2 !$= "" && isFile("Add-Ons/" @ $Pref::Server::DeathMatch::LoadAddon2 @ "/server.cs"))
		exec("Add-Ons/" @ $Pref::Server::DeathMatch::LoadAddon2 @ "/server.cs");
	
	if($Pref::Server::DeathMatch::LoadAddon3 !$= "" && isFile("Add-Ons/" @ $Pref::Server::DeathMatch::LoadAddon3 @ "/server.cs"))
		exec("Add-Ons/" @ $Pref::Server::DeathMatch::LoadAddon3 @ "/server.cs");
	
	if($Pref::Server::DeathMatch::LoadAddon4 !$= "" && isFile("Add-Ons/" @ $Pref::Server::DeathMatch::LoadAddon4 @ "/server.cs"))
		exec("Add-Ons/" @ $Pref::Server::DeathMatch::LoadAddon4 @ "/server.cs");
	
	if($Pref::Server::DeathMatch::LoadAddon5 !$= "" && isFile("Add-Ons/" @ $Pref::Server::DeathMatch::LoadAddon5 @ "/server.cs"))
		exec("Add-Ons/" @ $Pref::Server::DeathMatch::LoadAddon5 @ "/server.cs");
	
	if($Pref::Server::DeathMatch::LoadAddon6 !$= "" && isFile("Add-Ons/" @ $Pref::Server::DeathMatch::LoadAddon6 @ "/server.cs"))
		exec("Add-Ons/" @ $Pref::Server::DeathMatch::LoadAddon6 @ "/server.cs");
	
	if($Pref::Server::DeathMatch::LoadAddon7 !$= "" && isFile("Add-Ons/" @ $Pref::Server::DeathMatch::LoadAddon7 @ "/server.cs"))
		exec("Add-Ons/" @ $Pref::Server::DeathMatch::LoadAddon7 @ "/server.cs");
	
	if($Pref::Server::DeathMatch::LoadAddon8 !$= "" && isFile("Add-Ons/" @ $Pref::Server::DeathMatch::LoadAddon8 @ "/server.cs"))
		exec("Add-Ons/" @ $Pref::Server::DeathMatch::LoadAddon8 @ "/server.cs");
	
	if($Pref::Server::DeathMatch::LoadAddon9 !$= "" && isFile("Add-Ons/" @ $Pref::Server::DeathMatch::LoadAddon9 @ "/server.cs"))
		exec("Add-Ons/" @ $Pref::Server::DeathMatch::LoadAddon9 @ "/server.cs");
	
	if($Pref::Server::DeathMatch::LoadAddon10 !$= "" && isFile("Add-Ons/" @ $Pref::Server::DeathMatch::LoadAddon10 @ "/server.cs"))
		exec("Add-Ons/" @ $Pref::Server::DeathMatch::LoadAddon10 @ "/server.cs");
	
	//the addon exec stuff will be expanded in the future to be dynamic
	
	//chat emotes compatability
	if(isPackage(chatEmotesServer))
		deactivatePackage(chatEmotesServer);
	//we call peReplace in our own package if it exists
	
	echo("");
	
	//support_preferences compatatbility
	if($RTB::Hooks::ServerControl)
		DM_RegisterRTBPrefs();
	
	$DM::HasExecutedOnce = true;
	DM_Tick(($Pref::Server::DeathMatch::TimeLimit * 10));
	DM_TickAlt();
	DM_TipTick();
}

function DM_exec()
{
	setmodpaths(getmodpaths());
	exec("Add-Ons/Gamemode_Deathmatch/server.cs");
}